#include <iostream>
#include <vector>
#include <algorithm>
#include <stack>
using namespace std;
const int maxN=50010;
int n,m,k;
int ans=-1;
struct node{
    int v,tg;
    node(){}
    node(int a,int s){
        v=a;
        tg=s;
    }
};
vector<node> graph[maxN];
int dang[maxN],cnt,used[maxN],ansd[maxN],ansc;
bool dfs(int s,int maxtg,int blocked)
{
    for(int i=1;i<=n;i++)used[i]=0;
    used[blocked]=1;
    stack<int> st;
    st.push(s);
    while(!st.empty())
    {
        int tmp=st.top();
        st.pop();
        if(used[tmp])continue;
        used[tmp]=1;
        for(int i=0;i<graph[tmp].size();i++)
        {
            if(!used[graph[tmp][i].v] && graph[tmp][i].tg>maxtg)
            {
                st.push(graph[tmp][i].v);
            }
        }
    }
    for(int i=1;i<=n;i++)
    {
        if(used[i]==0 && i!=blocked)return 0;
    }
    return 1;
}
void findD(int maxtg)
{
    cnt=0;
    if(dfs(2,maxtg,1)==0){
        dang[cnt++]=1;
    }
    for(int i=2;i<=n;i++)
    {
        if(dfs(1,maxtg,i)==0){
            dang[cnt++]=i;
        }
    }
}
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int i,j,b,e,tg,mint=1e9+5,maxt=0;
    cin>>n>>m>>k;
    for(i=0;i<m;i++)
    {
        cin>>b>>e>>tg;
        graph[b].push_back(node(e,tg));
        graph[e].push_back(node(b,tg));
        mint=min(mint,tg);
        maxt=max(maxt,tg);
    }
    int le=mint,ri=maxt,mid;
    while(le<=ri)
    {
        mid=(le+ri)>>1;
        if(dfs(1,mid,0)==0)ri=mid-1;
        else {
            findD(mid);
            if(cnt>=k){
                ans=mid;
                ri=mid-1;
                ansc=cnt;
                for(i=0;i<cnt;i++){
                    ansd[i]=dang[i];
                }
            }
            else le=mid+1;
        }
    }
    cout<<ans<<" "<<ansc<<endl;
    for(i=0;i<ansc-1;i++)
    {
        cout<<ansd[i]<<" ";
    }if(ansc>0)cout<<ansd[ansc-1]<<endl;
    return 0;
}
/**
8 13 3
1 2 19
1 3 13
2 3 5
4 2 9
2 5 7
3 5 17
6 3 8
3 8 12
4 7 11
5 7 5
7 2 10
7 6 13
8 5 16
*/
