#include <iostream>
using namespace std;
string rev(string a)
{
    string ret = "";
    for(int i = a.size()-1; i >= 0; i --) ret += a[i];
    return ret;
}
string sum(string a, string b, int base)
{
    if(a.size() == 0) return b;
    if(b.size() == 0) return a;
    if(a == "0") return b;
    if(b == "0") return a;
    int tr = 0;
    string ret = "";
    for(int i = 0; i < max(a.size(),b.size()); i ++)
    {
        int aa, bb;
        if(i >= a.size()) aa = 0;
        else aa = a[i]-'0';
        if(i >= b.size()) bb = 0;
        else bb = b[i]-'0';
        //cout << aa << "+" << bb << endl;
        ret += (aa+bb+tr)%base+'0';
        tr = (aa+bb+tr)/base;
    }
    if(tr != 0) ret += tr+'0';
    return ret;
}
struct number
{
    int base;
    string in, rat, per;
    number()
    {
        in = "";
        rat = "";
        per = "";
        base = 10;
    }
    number(string init, int b)
    {
        base = b;
        string ini = "";
        int i = 0;
        while(i < init.size() && init[i] != '.')
        {
            ini += init[i];
            i ++;
        }
        in = rev(ini);
        i ++;

        string rati = "";
        while(i < init.size() && init[i] != '(')
        {
            rati += init[i];
            i ++;
        }
        rat = rev(rati);
        i ++;

        string peri = "";
        while(i < init.size() && init[i] != ')')
        {
            peri += init[i];
            i ++;
        }
        per = rev(peri);
    }
    void addtoin(string h)
    {
        in = sum(in, h, base);
    }
    void addtorat(string h)
    {
        string temp = sum(rat, h, base);
        if(temp.size() > rat.size())
        {
            addtoin("1");
            rat = temp.substr(0, temp.size()-1);
        }
        else
        rat = temp;
    }
    void addtoper(string h) // ONLY FOR ADDING TWO PERIODS OF EQUAL SIZE
    {
        if(per.size() != h.size()) return;
        string temp = sum(per+per, h+h, base);
        if(temp.size() > 2*per.size())
        {
            addtorat("1");
            per = temp.substr(per.size(), per.size());
        }
        else per = temp;
    }
    void norm()
    {
        // leading zeros
        while(in[in.size()-1] == '0')
        {
            in = in.substr(0, in.size()-1);
        }
        if(in.size() == 0) in = "0";
        // unnecessary zeros
        bool onlyzr = 1, onlyzp = 1;
        for(int i = 0; i < rat.size(); i ++)
        {
            if(rat[i] != '0')
            {
                onlyzr = 0;
                break;
            }
        }
        for(int i = 0; i < per.size(); i ++)
        {
            if(per[i] != '0')
            {
                onlyzp = 0;
                break;
            }
        }
        if(onlyzr && onlyzp)
        {
            rat = "";
            per = "";
        }
        if(onlyzp) per = "";
        if(per.size() == 0)
        {
            while(rat[0] == '0')
            {
                rat = rat.substr(1, rat.size()-1);
            }
        }
        // repetitive period
        int reached = 0;
        for(int i = 1; i < per.size(); i ++)
        {
            if(per[i] == per[reached]) reached ++;
            else reached = 0;
        }
        if(reached*2 >= per.size())
        {
            per = per.substr(0, per.size()-reached);
        }
        //period in nonperiod
        int seen = 0;
        for(int i = 0; i < rat.size(); i ++)
        {
            //cout << i << " " << seen << " " << rat[i] << " " << per[seen] << endl;
            if(rat[i] == per[seen])
            {
                seen ++;
            }
            else break;
            if(seen == per.size())
            {
                rat = rat.substr(seen, rat.size()-seen);
                i --;
                seen = 0;
            }
        }
        //.(9)
        if(per.size() == 1 && per[0]-'0' == base-1)
        {
            if(rat.size() > 0 ) addtorat("1");
            else addtoin("1");
            per = "";
        }
    }
    void output()
    {
        cout << rev(in);
        if(rat.size() + per.size() != 0) cout << '.';
        if(rat.size() != 0) cout << rev(rat);
        if(per.size() != 0) cout << '(' << rev(per) << ')';
        cout << endl;
    }
};
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    int base;
    string aa, bb;
    cin >> base >> aa >> bb;
    number a(aa, base), b(bb, base);
    a.norm();
    b.norm();
    while(a.per.size() != b.per.size())
    {
        if(a.per.size() > b.per.size()) b.per = b.per+b.per;
        if(a.per.size() < b.per.size()) a.per = a.per+a.per;
    }
    a.addtoper(b.per);
    a.addtorat(b.rat);
    a.addtoin(b.in);
    a.norm();
    a.output();
}
