#include <bits/stdc++.h>
//#include "Lgrader.cpp"
#include "hunter.h"

using namespace std;
template<class T, class T1> void chkmax(T &x, const T1 &y) { if(x < y) x = y; }
template<class T, class T1> void chkmin(T &x, const T1 &y) { if(x > y) x = y; }
const int MAXN = (1 << 10);

int n, m;
int dp[MAXN];
vector<vector<char> > a;

bool can_win(int stx, int sty)
{
	int l = sty, r = sty;
	while(l >= 0 && a[0][l] != '#') l--;
	while(r < m && a[0][r] != '#') r++;
	r--;
	l++;
	
	if((r - sty) % 2 == 1) return false;
	if((sty - l) % 2 == 1) return false;
	return true;
}

void play(int n, int m, const vector<vector<char> > &table)
{
	a = table;
	::n = n;
	::m = m;
	for(int i = 0; i < m; i++)
		if(a[0][i] != '#' && can_win(0, i))
		{
			pair<int, int> ret = makeMove(0, i);
			while(true)
			{
				if(ret.first == -1) return;
				if(ret.second < i) ret = makeMove(0, ret.second - 1);
				if(ret.second > i) ret = makeMove(0, ret.second + 1);
			}
			
			return;
		}
	
	pair<int, int> ret;	
	ret = makeMove(-1, -1);
	
	int st = ret.second;
	if(ret.first == -1)
	{
		return;
	}
	
	int l = st, r = st;
	while(l >= 0 && a[0][l] != '#') l--;
	while(r < m && a[0][r] != '#') r++;
	r--;
	l++;
	
	int b;
	if((r - st) % 2 == 1) b = r;
	if((st - l) % 2 == 1) b = l;
	
	while(true)
	{
		if(ret.first == -1) return;
		if(st <= b) ret = makeMove(0, ret.second + 1);
		if(st >= b) ret = makeMove(0, ret.second - 1);
	}		
}


