#include<iostream>
#include<vector>
#include "hunter.h"
using namespace std;
bool onTable(int i, int j,int n,int m, vector<vector<char>> t){
    return i>=0 && i<n && j>=0 && j<m && t[i][j]=='.';
}
vector<pair<int,int>> getMoves(int posX,int posY,int n, int m, vector<vector<char>> t)
{
    vector<pair<int,int>> moves;
    if(onTable(posY+1,posX,n,m,t))
        moves.push_back(make_pair(posY+1,posX));
    if(onTable(posY-1,posX,n,m,t))
        moves.push_back(make_pair(posY-1,posX));
    if(onTable(posY,posX+1,n,m,t))
        moves.push_back(make_pair(posY,posX+1));
    if(onTable(posY,posX-1,n,m,t))
        moves.push_back(make_pair(posY,posX-1));
    return moves;

}
void play(int n,int m,const vector<vector<char>> &table)
{
    if(n==1)
    {
        int x;
        if(m%2==0)
        {
            pair<int,int> p = makeMove(-1,-1);
            x=p.second;
            if(x%2==0)
            {
                x++;
                while(x<m)
                {
                    p=makeMove(x,0);
                    x+=2;
                }
                return;
            }
            else
            {
                x--;
                while(x>=0)
                {
                    p=makeMove(x,0);
                    x-=2;
                }
                return;
            }
        }
        else
        {
            pair<int,int> p = makeMove(0,2);
            x=p.second;
            if(x<2)
            {
                p=makeMove(0,0);
                return;
            }
            else
            {
                x+=2;
                while(x<m)
                {
                    p=makeMove(x,0);
                    x+=2;
                }
                return;
            }
        }
    }
}
