#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <cstring>
using namespace std;
const int MAX_N = 5e4 + 24;
const int MAX_M = 2e5 + 24;
int N, M, K, ans, ansbr;
bool dan[MAX_N], used[MAX_N];
struct dab
{
    int to, st;
    dab(){}
    dab(int _to, int _st)
    {
        to = _to;
        st = _st;
    }
};
vector <dab> v[MAX_N];
struct reb
{
    int f, t, s;
    reb(){}
    reb(int _f, int _t, int _s)
    {
        f = _f;
        t = _t;
        s = _s;
    }
};
reb a[MAX_M];
bool cmp(reb x, reb y)
{
    if(x.s < y.s)   return true;
    if(x.s == y.s && x.f < y.f)   return true;
    if(x.s == y.s && x.f == y.f && x.t < y.t)   return true;
    return false;
}
bool cmp1(dab x, dab y)
{
    if(x.st > y.st)   return true;
    if(x.st == y.st && x.to > y.to)   return true;
    return false;
}
void dfs(int curr, int no)
{
    ///cout << curr << endl;
    used[curr] = true;
    int sz = v[curr].size();
    for(int i = 0; i < sz; ++ i)
    {
        if(!used[v[curr][i].to] && (v[curr][i].to != no))   dfs(v[curr][i].to, no);
    }
}
int main()
{
    ios_base :: sync_with_stdio(0);
    cin.tie(0);
    cin >> N >> M >> K;
    for(int i = 1; i <= M; ++ i)
    {
        cin >> a[i].f >> a[i].t >> a[i].s;
        v[a[i].f].push_back(dab(a[i].t, a[i].s));
        v[a[i].t].push_back(dab(a[i].f, a[i].s));
    }
    sort(a + 1, a + M + 1, cmp);
    for(int i = 1; i <= N; ++ i)   sort(v[i].begin(), v[i].end(), cmp1);
    int ans = -1;
    int idx = 1;
    bool l = false;
    for(int i = 1; i <= N; ++ i)
    {
        if(dan[i] == true)   continue;
        for(int j = 1; j <= N; ++ j)
        {
            if(i != j)
            {
                dfs(j, i);
                ///cout << "\n\n";
                break;
            }
        }
        for(int j = 1; j <= N; ++ j)
        {
            if(used[j]  == false && j != i && !dan[i])
            {
                ///cout << "dan " << i << "\n\n\n";
                dan[i] = true;
                ++ ansbr;
            }
        }
        memset(used, false, sizeof(used));
    }
    ans = 0;
    if(ansbr >= K)
    {
        cout << ans << " " << ansbr << "\n";
        for(int i = 1; i <= N; ++ i)
        {
            if(dan[i] == true)   cout << i << " ";
        }
        cout << "\n";
    }
    while(1)
    {
        if(idx >= M)
        {
            cout << "-1 0\n";
            return 0;
        }
        ///cout << "idx = " << idx << endl;
        v[a[idx].f].pop_back();
        v[a[idx].t].pop_back();
        if(v[a[idx].f].size() == 0 || v[a[idx].t].size() == 0)
        {
            cout << "-1 0\n";
            return 0;
        }
        ++ idx;
        ///cout << a[idx - 1].s << " " << a[idx].s << endl;
        while(idx <= M && a[idx].s == a[idx - 1].s)
        {
            ///cout << "here " << idx << endl;
            v[a[idx].f].pop_back();
            v[a[idx].t].pop_back();
            if(v[a[idx].f].size() == 0 || v[a[idx].t].size() == 0)
            {
                l = true;
                break;
            }
            ++ idx;
        }
        for(int i = 1; i <= N; ++ i)
        {
            ///for(int j = 0; j < v[i].size(); ++ j)   cout << v[i][j].to << " ";
            ///cout << endl;
        }
        if(l == true)
        {
            cout << "-1 0\n";
            return 0;
        }
        for(int i = 1; i <= N; ++ i)
        {
            if(dan[i] == true)   continue;
            for(int j = 1; j <= N; ++ j)
            {
                if(i != j)
                {
                    dfs(j, i);
                    ///cout << "\n\n";
                    break;
                }
            }
            for(int j = 1; j <= N; ++ j)
            {
                if(used[j]  == false && j != i && !dan[i])
                {
                    ///cout << "dan " << i << "\n\n\n";
                    dan[i] = true;
                    ++ ansbr;
                }
            }
            memset(used, false, sizeof(used));
        }
        ans = a[idx - 1].s;
        if(ansbr >= K)   break;
        ///cout << "here\n";
    }
    cout << ans << " " << ansbr << "\n";
    for(int i = 1; i <= N; ++ i)
    {
        if(dan[i] == true)   cout << i << " ";
    }
    cout << "\n";
    return 0;
}
/**
8 13 3
1 2 19
1 3 13
2 3 5
4 2 9
2 5 7
3 5 17
6 3 8
3 8 12
4 7 11
5 7 5
7 2 10
7 6 13
8 5 16
**/
