#include "hunter.h"
#include<iostream>
#include<vector>
#include<utility>
#include<queue>
//#include<conio.h>
using namespace std;

char a[128][128];
int m,n;

size_t countArea(int i, int j)
{
    size_t t=0;
    if(a[i][j]=='#' || a[i][j]=='@' || i<0 || j<0 || i>=n || j>=m)return 0;
    queue< pair<int,int> > q,q2;
    pair<int,int> p;
    q.push(make_pair(i,j));
    while(!q.empty())
    {
        p=q.front();q.pop();q2.push(p);
        if(a[p.first][p.second]=='#' || a[p.first][p.second]=='@')continue;
        a[p.first][p.second]='@';t++;
        if(a[p.first+1][p.second]=='.')q.push(make_pair(p.first+1,p.second));
        if(p.first)if(a[p.first-1][p.second]=='.')q.push(make_pair(p.first-1,p.second));
        if(a[p.first][p.second+1]=='.')q.push(make_pair(p.first,p.second+1));
        if(p.second)if(a[p.first][p.second-1]=='.')q.push(make_pair(p.first,p.second-1));
    }
    while(!q2.empty())
    {
        p=q2.front();
        a[p.first][p.second]='.';
        q2.pop();
    }
    return t;
}

void play(int n, int m, const vector< vector<char> > &table)
{
    int i,j,t;
    pair<int,int> p;
    ::m=m;::n=n;
    for(i=0;i<n;i++)
     for(j=0;j<m;j++)
      a[i][j]=table[i][j];
    for(i=0;i<n;i++)
     for(j=0;j<m;j++)
      if(countArea(i,j)&1)goto out;
    out:;
    if(i==n && j==m)p=makeMove(-1,-1);
    else {a[i][j]='#';p=makeMove(i,j);}
    i=p.first;j=p.second;a[i][j]='#';

    loop:;
    //cout<<"i j  "<<i<<' '<<j<<endl;
    if(i<n-1 && countArea(i+1,j)&1)
    {//cout<<"Case 1\n";
        a[i+1][j]='#';
        if(i+1==n-1)if(!(countArea(i+1,j-1)&1) && !(countArea(i+1,j-1)&1))p=makeMove(i+1,j);
        else a[i+1][j]='.';
    }
    else if(i>0 && countArea(i-1,j)&1)
    {//cout<<"Case 2\n";
        a[i-1][j]='#';
        if(i-1==0)if(!(countArea(i-1,j-1)&1) && !(countArea(i-1,j-1)&1))p=makeMove(i-1,j);
        else a[i-1][j]='.';
    }
    else if(j<m-1 && countArea(i,j+1)&1)
    {//cout<<"Case 3\n";
        a[i][j+1]='#';
        if(j+1==m-1)if(!(countArea(i-1,j+1)&1) && !(countArea(i+1,j+1)&1))p=makeMove(i,j+1);
        else a[i][j+1]='.';
    }
    else {/*cout<<"Case 4\n";*/a[i][j-1]='#';p=makeMove(i,j-1);}
    i=p.first;j=p.second;
    if(p.first!=-1 && p.second!=-1){a[i][j]='#';goto loop;}






    /**cout<<endl;
    for(int i=0;i<n;i++)
    {
        for(int j=0;j<m;j++)cout<<a[i][j];
        cout<<endl;
    }
    cout<<endl;*/
}

/**
int main()
{
    cin>>n>>m;
    for(int i=0;i<n;i++)cin>>a[i];
    cout<<countArea(0,0)<<endl;
}

/**
cout<<endl<<p.first<<' '<<p.second<<endl;;
for(int i=0;i<n;i++)
{
    for(int j=0;j<m;j++)cout<<a[i][j];
    cout<<endl;
}
cout<<endl;getch();
*/
