#include<iostream>
#include<algorithm>
#include<string>
using namespace std;
int toNum(char c){
	if(c>='0'&&c<='9') return c-'0';
	return 10+c-'A';
}
char toChar(char c){
	if(c>=0&&c<=9) return c+'0';
	return c-10+'A';
}
void addToPeriod(string &frac, string &per){
	if(per.size()==0) return;
	while(frac.size()!=0&&frac[frac.size()-1]==per[per.size()-1]){
		per=frac[frac.size()-1]+per;
		per.erase(per.size()-1);
		frac.erase(frac.size()-1);
	}
}
const int MOD1=1e9+7,MOD2=1e9+9;
const int mult1=37,mult2=41;
bool fixPeriod(string &per){
	long long hash1Fr=0,hash2Fr=0;
	long long hash1Bc=0,hash2Bc=0;
	long long multer1=1,multer2=1;
	int i=0,j=per.size()-1;
	while(i<j){
		hash1Fr*=mult1;hash1Fr%=MOD1;
		hash2Fr*=mult2;hash2Fr%=MOD2;
		hash1Fr+=toNum(per[i]);hash1Fr%=MOD1;
		hash2Fr+=toNum(per[i]);hash2Fr%=MOD2;
		i++;
		
		hash1Bc+=multer1*toNum(per[j]);hash1Bc%=MOD1;
		hash2Bc+=multer2*toNum(per[j]);hash2Bc%=MOD2;
		multer1*=mult1;multer1%=MOD1;
		multer2*=mult2;multer2%=MOD2;
		j--;
		if(hash1Fr==hash1Bc&&hash2Fr==hash2Bc){
			per.erase(j+1,per.size()-j-1);
			return true;
		}
	}
	return false;
}
void getNum(string num[]){
	int ind=0;
	char c;
	while(cin.get(c)){
		if(c=='\n') break;
		if(c=='.'||c=='('){
			ind++;
		}
		if((c>='0'&&c<='9')||(c>='A'&&c<='Z')){
			num[ind]+=c;
		}
	}
	while(num[0].size()!=0&&num[0][0]=='0') num[0].erase(num[0].begin());
	addToPeriod(num[1],num[2]);
	while(fixPeriod(num[2]));
}
int main(){
	cin.tie(NULL);
	ios::sync_with_stdio(false);
	int b;
	cin>>b;
	char c;
	cin.get(c);
	string num1[3],num2[3];
	getNum(num1);
	getNum(num2);
	while(num1[1].size()<num2[1].size()){
		if(num1[2]==""){
			num1[1]+='0';
		}else{
			num1[1]+=num1[2][0];
			num1[2]+=num1[2][0];
			num1[2].erase(num1[2].begin());
		}
	}
	while(num1[1].size()>num2[1].size()){
		if(num2[2]==""){
			num2[1]+='0';
		}else{
			num2[1]+=num2[2][0];
			num2[2]+=num2[2][0];
			num2[2].erase(num2[2].begin());
		}
	}
	string ans[3];
	int prenos=0;
	if(num2[2].size()==0){
		ans[2]=num1[2];
	}else{
		if(num1[2].size()==0){
			ans[2]=num2[2];
		}else{
			int len1=num1[2].size(),len2=num2[2].size();
			int r=1,pom1=len1,pom2=len2;
			while(r!=0){
				r=pom1%pom2;
				pom1=pom2;
				pom2=r;
			}
			int mul=len1*len2/pom1;
			int i=len1-1,j=len2-1;
			for(int p=0;p<mul;p++){
				int val=toNum(num1[2][i])+toNum(num2[2][j])+prenos;
				prenos=val/b;
				val%=b;
				ans[2]=ans[2]+toChar(val);
				i=(i+len1-1)%len1;
				j=(j+len2-1)%len2;
			}
			if(prenos){
				int last=0;
				while(prenos&&last<mul&&ans[2][last]==toChar(b-1)){
					ans[2][last]='0';
					last++;
				}
				if(last==mul){
					ans[2]="";
				}else{
					ans[2][last]=toChar(toNum(ans[2][last])+1);
				}
			}
			reverse(ans[2].begin(),ans[2].end());
			bool toOne=true;
			for(int i=0;i<ans[2].size();i++){
				if(ans[2][i]!=toChar(b-1)){
					toOne=false;
					break;
				}
			}
			if(toOne){
				prenos++;
				ans[2]="";
			}
		}
	}
	for(int i=num1[1].size();i>0;i--){
		int val=toNum(num1[1][i-1])+toNum(num2[1][i-1])+prenos;
		prenos=val/b;
		val%=b;
		ans[1]+=toChar(val);
	}
	bool zeros=true;
	for(int i=0;i<ans[1].size();i++){
		if(ans[1][i]!='0'){
			zeros=false;
			break;
		}
	}
	reverse(ans[1].begin(),ans[1].end());
	addToPeriod(ans[1],ans[2]);
	while(fixPeriod(ans[2]));
	int i=num1[0].size()-1;
	int j=num2[0].size()-1;
	while(i>=0||j>=0){
		int val=prenos;
		if(i>=0){
			val+=toNum(num1[0][i]);
			i--;
		}
		if(j>=0){
			val+=toNum(num2[0][j]);
			j--;
		}
		prenos=val/b;
		val%=b;
		ans[0]+=toChar(val);
	}
	if(prenos){
		ans[0]+='1';
	}
	reverse(ans[0].begin(),ans[0].end());
	cout<<ans[0];
	if((ans[1].size()!=0||ans[2].size()!=0)&&!(zeros&&ans[2].size()==0)){
		cout<<".";
		cout<<ans[1];
		if(ans[2].size()!=0){
			cout<<"("<<ans[2]<<")";
		}
	}
	cout<<"\n";
	return 0;
}

