#include "hunter.h"
#include <iostream>
#include <vector>
#include <utility>
using namespace std;

//pair<int,int> makeMove(int,int) {}

pair<int,int> findOdd(const vector<char>& table)
{
    pair<int,int> res(-1,-1);
    for(size_t i=0; i<table.size(); ++i)
        switch(table[i])
        {
        case '.':
            if(res.first==-1) res.first=res.second=i;
            else ++res.second;
            break;
        case '#':
            if(!(res.second-res.first&1)) return res;
            res.first=-1;
        }
    if(!(res.second-res.first&1)) return res;
    return make_pair(-1,-1);
}

void play(int n, int m, const vector<vector<char>>& table)
{
    if(n==1)
    {
        pair<int,int> t=findOdd(table[0]), p;
        if(t.first==-1)
        {
            p=makeMove(-1,-1);
            vector<char> t2=table[0];
            t2[p.second]='#';
            t=findOdd(t2);
            int i=0;
            if(t.first>p.second)
                do
                {
                    p=makeMove(0,t.first+i);
                    i+=2;
                }
                while(p.first!=-1);
            else
                do
                {
                    p=makeMove(0,t.second-i);
                    i+=2;
                }
                while(p.first!=-1);
        }
        else
        {
            int i=0;
            p=makeMove(0,t.first);
            while(p.first!=-1)
            {
                i+=2;
                p=makeMove(0,t.first+i);
            }
        }
    }
    vector<vector<char>> t2=table;
    pair<int,int> p;
    if(!(n*m&1))
    {
        p=makeMove(-1,-1);
        while(p.first!=-1)
        {
            t2[p.first][p.second]='#';
            if(p.first && t2[p.first-1][p.second]=='.') p=makeMove(p.first-1,p.second), t2[p.first-1][p.second]='#';
            else if(p.second<m-1 && t2[p.first][p.second+1]=='.') p=makeMove(p.first,p.second+1), t2[p.first][p.second+1]='#';
            else if(p.first<n-1 && t2[p.first+1][p.second]=='.') p=makeMove(p.first+1,p.second), t2[p.first+1][p.second]='#';
            else p=makeMove(p.first,p.second-1), t2[p.first][p.second-1]='#';
        }
    }
    else
    {
        p=makeMove(0,0);
        t2[0][0]='#';
        while(p.first!=-1)
        {
            t2[p.first][p.second]='#';
            if(p.first && t2[p.first-1][p.second]=='.') p=makeMove(p.first-1,p.second), t2[p.first-1][p.second]='#';
            else if(p.second<m-1 && t2[p.first][p.second+1]=='.') p=makeMove(p.first,p.second+1), t2[p.first][p.second+1]='#';
            else if(p.first<n-1 && t2[p.first+1][p.second]=='.') p=makeMove(p.first+1,p.second), t2[p.first+1][p.second]='#';
            else p=makeMove(p.first,p.second-1), t2[p.first][p.second-1]='#';
        }
    }

}

//int main() {}
