#include<iostream>
#include<stack>
#include<cstring>
#include<vector>
#include<algorithm>
#define MAX 200000
#define MX 40000

using namespace std;
int n,m,k,br=0;
char roads[MX][MX];
int used[MX];
int blocked[MX];
struct road
{
    int city1;
    int city2;
    long long snow;
    road() {}
    road(int a, int b, long long c)
    {
        city1=a;
        city2=b;
        snow =c;
    }
};

road i[MAX];
vector <road> v[MX];
vector <int> ans;
stack <int> S;
int blocked_cities=0;
bool cmp(road a, road b)
{
    return a.snow<b.snow;
}

void close_road()
{
    int a=br;
    while(a<m && i[a].snow==i[br].snow )
    {
        int x,y;
        x=i[a].city1;
        y=i[a].city2;
        roads[x][y]='0';
        roads[y][x]='0';
        a++;
    }
    br=a;
}
int br1=1;
int dfs(int s)
{
    used[s]=1;
    S.push(s);
    while(!S.empty())
    {    bool f=false;

        int p=S.top();
        for(int a=0;a<v[p].size(); a++)
        {
            if(used[v[p][a].city2]==0)
            {


            int x,y;
            x=v[p][a].city1;
            y=v[p][a].city2;
            if(roads[x][y]=='1')
            {
                f=true;
                br1++;
                used[y]=1;
                S.push(y);
            }}

        }
        if(f==false)
            S.pop();
    }

    return br1;

}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cin>>n>>m>>k;
    for(int a=0; a<m; a++)
    {
        cin>>i[a].city1>>i[a].city2>>i[a].snow;
        road p;
        p.city1=i[a].city2;
        p.city2=i[a].city1;
        p.snow=i[a].snow;
        v[i[a].city1].push_back(i[a]);
        v[i[a].city2].push_back(p);
        roads[p.city1][p.city2]='1';
        roads[p.city2][p.city1]='1';

    }
    sort(i, i + m, cmp);
    bool case2=true;
    while(br<m)
    {
        close_road();
        for(int a=1; a<=n; a++)
        {
            if(blocked[a]==1)
                continue;
            br1=2;
            memset(used,0,sizeof(used));
            used[a]=1;
            if(a==n)
            {
                if(dfs(a-1)<n)
                {
                    blocked_cities++;
                    blocked[a]=1;
                    ans.push_back(a);
                }
            }
            if(dfs(a+1)<n)
            {
                blocked_cities++;
                blocked[a]=1;
                ans.push_back(a);
            }

        }
        if(blocked_cities==n)break;
        if(blocked_cities>=k)
        {
            cout<<i[br-1].snow<<" ";
            cout<<blocked_cities<<endl;
            case2=false;
            sort(ans.begin(),ans.end());
            for(int a=0; a<ans.size()-1; a++)
                cout<<ans[a]<<" ";
            cout<<ans[ans.size()-1]<<endl;
            break;
        }
    }
    if(case2==true)
    {
        cout<<-1<<" "<<0<<endl;
    }
    return 0;
}
