#include "hunter.h"
#include <vector>
#define fi first
#define se second
using namespace std;

void play(int n, int m, const vector<vector<char>> &table)
{
    if (n == 1)
    {
        int f = 0;
        while (f < m and table[0][f] == '#') f++;
        int l = f;
        while (l + 1 < m and table[0][l + 1] == '.') l++;

        if (f == m or l == m)
        {
            makeMove(-1, -1);
            return;
        }
        if ((l - f) % 2 == 0)
        {
            auto r = makeMove(0, f);
            while (r.fi != -1 and r.se != -1)
            {
                r = makeMove(r.fi, r.se + 1);
            }
        }
        else
        {
            auto r = makeMove(-1, -1);
            if (r.fi == -1 and r.se == -1) return;
            if ((r.se - f) % 2 == 0)
            {
                do
                {
                    r = makeMove(r.fi, r.se + 1);
                }
                while (r.fi != -1 and r.se != -1);
            }
            else
            {
                do
                {
                    r = makeMove(r.fi, r.se - 1);
                }
                while (r.fi != -1 and r.se != -1);
            }
        }
    }
}
