#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
using namespace std;

vector <int> a,b,res;
int base;
string s1,s2,partans;

int Digit(char ch)
{
  if(ch>='0' && ch<='9')
   return ch-'0';

 return 10+(ch-'A');
}

char Character(int digit)
{
  if(digit>=0 && digit<=9)
   return digit+'0';

 return (digit-10)+'A';
}

void FindSum()
{
 int i,carry=0,len,sum;

 len=min(a.size(),b.size());
  for(i=0;i<len;i++)
  {
   sum=a[i]+b[i]+carry;
   res.push_back(sum%base);
   carry=sum/base;
  }

  for(i=len;i<a.size();i++)
  {
   sum=a[i]+carry;
   res.push_back(sum%base);
   carry=sum/base;
  }

  for(i=len;i<b.size();i++)
  {
   sum=b[i]+carry;
   res.push_back(sum%base);
   carry=sum/base;
  }

  while(carry!=0)
  {
   res.push_back(carry%base);
   carry/=base;
  }

  while(res.back()==0)
   res.pop_back();
}

int main()
{

int i,limit;

ios::sync_with_stdio(false);
cin.tie(NULL);

cin>>base;
cin>>s1>>s2;

limit=s1.size()-1;
 for(i=0;i<s1.size();i++)
 {
  if(s1[i]=='.')
  {
   limit=i-1;
   break;
  }
 }

 for(i=limit;i>=0;i--)
  a.push_back(Digit(s1[i]));

limit=s2.size()-1;
 for(i=0;i<s2.size();i++)
 {
  if(s2[i]=='.')
  {
   limit=i-1;
   break;
  }
 }

 for(i=limit;i>=0;i--)
  b.push_back(Digit(s2[i]));

FindSum();

 for(i=res.size()-1;i>=0;i--)
  partans.push_back(Character(res[i]));

 for(i=0;i<partans.size();i++)
  cout<<partans[i];

cout<<endl;

return 0;
}
