#include <iostream>
#include <string>

using namespace std;

int n;

string normalise (string* a)
{
    string res = "";

    int idx = 0;
    //nachalni 0
    while (idx < (*a).size() and (*a)[idx] == '0')
    {
        ++idx;
    }

    //predi .
    if (idx == (*a).size())
    {
        return "0";
    }
    else if ((*a)[idx] == '.')
    {
        res += '0';
    }
    else
    {
        for (; idx < (*a).size() and (*a)[idx] != '.'; ++idx)
        {
            res += (*a)[idx];
        }
    }

    int pointIdx = idx;
    ++idx;

    //sled . predi (
    string drobna = "";
    for (; idx < (*a).size() && (*a)[idx] != '('; ++idx)
    {
        drobna += (*a)[idx];
    }

    //sled (
    if (idx < (*a).size())
    {
        ++idx; //(
        string period = "";
        period += (*a)[idx];

        for (int i = 1; idx + i < (*a).size() - 1;)
        {
            //cout << i << ' ' << period << '\n';
            if ((*a)[idx + i] != period[0])
            {
                period += (*a)[idx + 1];
                ++i;
            }
            else
            {
                //cout << "suvpadenie\n";
                bool ok = true;
                if ((*a).size() - 1 - idx - i < period.size())
                {
                    for (int j = idx + period.size(); j < (*a).size() - 1; ++j)
                    {
                        period += (*a)[j];
                    }
                }
                else
                {
                    for (int j = 1; j < period.size() && idx + i + j < (*a).size() - 1; ++j)
                    {
                        if ((*a)[idx + i + j] != period[j] or
                                (j + 1 < period.size() && idx + i + j + 1 == (*a).size() - 1))
                        {
                            ok = false;
                            for (int p = idx + period.size(); p < idx + i + j; ++p)
                            {
                                period += (*a)[p];
                            }
                            i += j;
                            break;
                        }
                    }
                }

                if (ok)
                {
                    i += period.size();
                }
            }
        }

        //cout << "period -> "<< period << '\n';

        if (drobna == period && period != "0")
        {
            res += ".(";
            res += period;
            res += ')';
        }
        else
        {
            //cout << "drobna -> " << drobna.size() << ' ' << drobna << "#\n";
            //cout << "period.size() -> " << period.size() << '\n';
            int dulDrobna = drobna.size();
            bool same = true;
            while (same)
            {
                same = true;
                for (int i = dulDrobna - period.size(), k = 0; i < dulDrobna; ++i, ++k)
                {
                    //cout << i << ' ' << drobna[i] << ' ' << period[k] << '\n';
                    if (drobna[i] != period[k])
                    {
                        same = false;
                        break;
                    }
                }
                if (same)
                {
                    dulDrobna -= period.size();
                }
            }
            //cout << "dulDrobna -> "<< dulDrobna << '\n';
            string newDrobna = "";
            for (int i = 0; i < dulDrobna; ++i)
            {
                newDrobna += drobna[i];
            }
            res += '.';
            if (newDrobna.size() > 0)
            {
                res += newDrobna;
            }
            if (period != "0")
            {
                res += '(';
                res += period;
                res += ')';
            }
        }
    }

    return res;
}

int main ()
{
    cin.tie(NULL);
    ios::sync_with_stdio(false);

    string input1, input2;
    cin >> n >> input1 >> input2;

    string a = normalise(&input1);
    //cout << a << '\n';
    string b = normalise(&input2);
    //cout << b << '\n';

    string c = "";
    int aIdx = a.size() - 1, bIdx = b.size() - 1;
    int prenos = 0;

    if (a[aIdx] == ')' && b[bIdx] == ')')
    {
        --aIdx;
        --bIdx;
        c += ')';
        while (a[aIdx] != '(' or b[bIdx] != '(')
        {
            int sum = prenos;
            prenos = 0;
            if (a[aIdx] != '(')
            {
                sum += a[aIdx];
                if (a[aIdx] >= '0' and a[aIdx] <= '9')
                {
                    sum -= '0';
                }
                else
                {
                    sum -= 'A' - 10;
                }
                --aIdx;
            }
            if (b[bIdx] != '(')
            {
                sum += b[bIdx];
                if (b[bIdx] >= '0' and b[bIdx] <= '9')
                {
                    sum -= '0';
                }
                else
                {
                    sum -= 'A' - 10;
                }
                --bIdx;
            }
            //cout << sum << '\n';
            if (sum >= n)
            {
                prenos = sum / n;
                sum %= n;
            }

            if (sum < 10)
            {
                c += sum + '0';
            }
            else
            {
                c += sum - 10 + 'A';
            }
        }
        c += '(';
    }
    else if (a[aIdx] == ')')
    {
        while (a[aIdx] != '(')
        {
            c += a[aIdx];
            --aIdx;
        }
        c += '(';
    }
    else if (b[bIdx] == ')')
    {
        while (b[bIdx] != '(')
        {
            c += b[bIdx];
            --bIdx;
        }
        c += '(';
    }

    //cout << c << '\n';

    --aIdx;
    --bIdx;

    while (a[aIdx] != '.' or b[bIdx] != '.')
    {
        int sum = prenos;
        prenos = 0;
        if (a[aIdx] != '.')
        {
            sum += a[aIdx];
            if (a[aIdx] >= '0' and a[aIdx] <= '9')
            {
                sum -= '0';
            }
            else
            {
                sum -= 'A' - 10;
            }
            --aIdx;
        }
        if (b[bIdx] != '.')
        {
            sum += b[bIdx];
            if (b[bIdx] >= '0' and b[bIdx] <= '9')
            {
                sum -= '0';
            }
            else
            {
                sum -= 'A' - 10;
            }
            --bIdx;
        }
        //cout << sum << '\n';
        if (sum >= n)
        {
            prenos = sum / n;
            sum %= n;
        }

        if (sum < 10)
        {
            c += sum + '0';
        }
        else
        {
            c += sum - 10 + 'A';
        }
    }
    c += '.';

    //cout << c << '\n';

    --aIdx;
    --bIdx;

    while (aIdx >= 0 or bIdx >= 0)
    {
        int sum = prenos;
        prenos = 0;
        if (aIdx >= 0)
        {
            sum += a[aIdx];
            if (a[aIdx] >= '0' and a[aIdx] <= '9')
            {
                sum -= '0';
            }
            else
            {
                sum -= 'A' - 10;
            }
            --aIdx;
        }
        if (bIdx >= 0)
        {
            sum += b[bIdx];
            if (b[bIdx] >= '0' and b[bIdx] <= '9')
            {
                sum -= '0';
            }
            else
            {
                sum -= 'A' - 10;
            }
            --bIdx;
        }
        //cout << sum << '\n';
        if (sum >= n)
        {
            prenos = sum / n;
            sum %= n;
        }

        if (sum < 10)
        {
            c += sum + '0';
        }
        else
        {
            c += sum - 10 + 'A';
        }
    }

    if (prenos > 0)
    {
        if (prenos < 10)
        {
            c += prenos + '0';
        }
        else
        {
            c += prenos - 10 + 'A';
        }
    }


    //cout << c << '\n';

    for (int i = 0; i < c.size() / 2; ++i)
    {
        swap(c[i], c[c.size() - 1 - i]);
    }
    c = normalise(&c);
    //cout << c << '\n';

    char special = n - 1;
    bool imaLiPeriod = false;
    if (c[c.size() - 1] == ')')
    {
        imaLiPeriod = true;
    }
    if (special < 10)
    {
        special += '0';
    }
    else
    {
        special += 'A' - 10;
    }
    if (c[c.size() - 1] == ')' and c[c.size() - 2] == special and c[c.size() - 3] == '(')
    {
        prenos = 1;
        imaLiPeriod = false;
    }
    //cout << special << ' ' << imaLiPeriod << '\n';
    for (int i = c.size() - 4; i >= 0 and prenos > 0; --i)
    {
        if (c[i] != '.' and c[i] != '(' and c[i] != ')')
        {
            int curr = c[i];
            if (c[i] >= '0' and c[i] <= '9')
            {
                curr -= '0';
            }
            else
            {
                curr -= 'A';
            }

            curr += prenos;
            prenos = 0;


            if (curr >= n)
            {
                prenos = curr / n;
                curr %= n;
            }

            if (curr < 10)
            {
                c[i] = curr + '0';
            }
            else
            {
                c[i] = curr - 10 + 'A';
            }
        }
    }

    //c = normalise(c);
    //cout << c << '\n';
    for (int i = 0; i < c.size(); ++i)
    {
        if ((c[i] == '(' or (c[i] == '.' and c[i + 1] == '(')) and !imaLiPeriod)
        {
            //cout << "da";
            break;
        }
        cout << c[i];
    }

    return 0;
}
