#include <iostream>
#include <queue>
#include <cmath>
#include <vector>
#include <algorithm>
using namespace std;
int n, m, k;

int d[(1<<20)];
int p[(1<<20)], dsu[(1<<20)];
vector < int > chs[(1<<20)];
vector < pair < int, int > > neigh[(1<<20)];
vector < pair < int , pair < int, int > > > nodes;
bool isD[(1<<20)];
void setTr ( int x ) {
    d[x] = d[ p[x] ] +1;
    for ( int i = 0 ; i < chs[x].size() ; i ++ ) {
        if ( chs[x][i] == p[x] ) {
            swap( chs[x][i], chs[ x ][ chs[x].size()-1 ] );
            chs[x].pop_back();
            i --;
        }else {
            p[ chs[x][i] ] = x;
            setTr ( chs[x][i] );
        }
    }
}


int getP ( int x ) {
    return x == dsu[x] ? x : dsu[x] = getP( dsu[x] );
}

bool mergeV ( int a, int b ) {

    int p1 = getP( a ), p2 = getP ( b );
    if ( p1 == p2 ) { return 0; }

    dsu[p1] = p2;
    return 1;
}
priority_queue < pair < int, pair < int, int > > > q;
bool used[(1<<20)];

int checkD ( int x ) {
    if ( chs[x].size() == 0 ) { return 0; }

    for ( int i = 1 ; i < chs[x].size() ; i ++ ) {
        if ( getP( chs[x][0] ) != getP( chs[x][i] ) ) { return 1; }
    }
    if ( p[x] ) {
        if ( getP( chs[x][0] ) != getP( p[x] ) ) { return 1; }
    }
    return 0;
}

int cntD () {
    int ret = 0;
    for ( int i = 1; i <= n ; i ++ ) {
        ret += checkD(i) ;
    }
    return ret;
}

vector < int > anss;

void mergePath ( int a, int b ) {
    if ( p[a] == b || p[b] == a ) { return; }
//    cout << "merging " << a << " and " << b << " : " << cntD() << "\n";

    mergeV ( a, b );

    for ( ; d[a] != d[b] ; ) {
        if ( d[a] > d[b] ) {
            mergeV( a, p[a] );
            a = p[a];
        }else {
            mergeV( b, p[b] );
            b = p[b];
        }
    }

}

int main () {

    cin >> n >> m >> k;

    for ( int i = 0 ; i <= n ; i ++ ) { dsu[i] = i; }

    for ( int i = 0 ; i < m ; i ++ ) {
        int a, b, s;
        cin >> a >> b >> s;
        nodes.push_back( make_pair( s, make_pair( a, b ) ) );
        neigh[a].push_back( make_pair( b, s ) );
        neigh[b].push_back( make_pair( a, s ) );
    }
    q.push( make_pair( 0, make_pair( 1, 0 ) ) );

    int minNode = (1<<20); /// < ---

    for ( ; !q.empty() ; ) {
        int len = q.top().first, from = q.top().second.second, to = q.top().second.first;
        q.pop();
        if ( used[ to ] ) { continue; }
        used[to] = 1;
        chs[to].push_back( from );
        chs[from].push_back( to );
        if ( len ) { minNode = min( minNode, len ); }
//        cout << "added node " << minNode << " , " << len << "\n";

        for ( int i = 0 ; i < neigh[to].size() ; i ++) {
            q.push( make_pair( neigh[to][i].second, make_pair( neigh[to][i].first, to ) ) );
        }
    }
    p[1]=0;
    setTr (1);

    /*
    for ( int i = 1 ; i <= n ; i ++ ) {
        cout << i << " : ";
        for( int j = 0 ; j < chs[i].size() ; j ++ ) {
            cout << chs[i][j] << " ";
        }
        cout << "\n";
    }
    */


    sort( nodes.begin(), nodes.end() );
    reverse( nodes.begin(), nodes.end() );

    int ss = 0;

    for ( ; ss < nodes.size() && nodes[ss].first >= minNode ; ss ++ ) {
        int a = nodes[ss].second.first, b = nodes[ss].second.second;
        mergePath( a, b );
    }
    if ( cntD() < k ) {
        cout << 12/0 << "\n";
    }

    for ( ; ss < nodes.size() ; ) {

        int j = ss;
        for ( ; j < nodes.size() && nodes[ss].first == nodes[j].first ; j ++ ) {}

        for ( int ck = ss ; ck < j ; ck ++ ) {
            int a = nodes[ck].second.first, b = nodes[ck].second.second;
            mergePath( a, b );
        }


//        cout << cntD () << " : " << nodes[i].first << " < " << minNode << "\n";

     //   if ( minNode < nodes[i].first ) {

      //  }


        if ( cntD() < k ) {

            cout << nodes[ss].first << " ";
            cout << anss.size() << "\n";
            for ( int s = 0 ; s < anss.size() ; s ++ ) {
                cout << anss[s] << " ";
            }
            cout << "\n";
            return 0;
        }

        anss.clear();
        for ( int s = 1 ; s <= n ; s ++ ) {
            if ( checkD(s) ) {
                anss.push_back( s );
            }
        }
        ss = j;

    }

    if ( cntD() >= k ) {
        anss.clear();
        for ( int i = 1 ; i <= n ; i ++ ) {
            if ( checkD(i) ) {
                anss.push_back( i );
            }
        }
        cout << "0 " << anss.size() << "\n";
        for ( int i = 0 ; i < anss.size() ; i ++ ) {
            cout << anss[i] << " ";
        }
        cout << "\n";
        return 0;
    }

    cout << "-1 0\n";
    return 0;
}
/*
8 13 3
1 2 19
1 3 13
2 3 5
4 2 9
2 5 7
3 5 17
6 3 8
3 8 12
4 7 11
5 7 5
7 2 10
7 6 13
8 5 16


3 3 1
1 2 42
2 3 42
1 3 666


*/
