#include "hunter.h"
#include<vector>
#include<algorithm>
using namespace std;
bool cmp (pair<int, int> x, pair<int,int> y)
{
    if (x.first!=y.first)
        return x.first>y.first;
    return x.second<y.second;
}
void play (int n, int m, const vector<vector<char> > &table)
{
    vector<pair<int,int> > v;
    if (n==1)
    {
        int br=0,pos=0;
        for (int i=0; i<m; i++)
        {
            if (table[0][i]=='.')
            {
                if (br==0)
                    pos=i;
                br++;
            }
            else
            {
                if (br!=0)
                {
                    v.push_back(make_pair(br,pos));
                    br=0;
                }
            }
        }
        if (br!=0)
            v.push_back(make_pair(br,pos));
        sort(v.begin(),v.end(),cmp);

        pair<int,int> z;
        if (v.size()==1)
        {
            int s,f,c;
            s=0;
            while (table[0][s]=='#')
                s++;
            f=m-1;
            while (table[0][f]=='#')
                f--;
            c=f-s-1;
            if (c%2==0)
            {
                z=makeMove(-1,-1);
                int q;
                if (z.second<c/2+s)
                {
                    q=z.second;
                    while (z!=make_pair(-1,-1))
                        z=makeMove(0,q++);
                }
                else
                {
                    q=z.second;
                    while (z!=make_pair(-1,-1))
                        z=makeMove(0,--q);
                }
            }
            else
            {
                int q;
                z=makeMove(0,c/2+s);
                if (z.second<c/2+s)
                {
                    q=c/2+s;
                    while (z!=makeMove(-1,-1))
                        makeMove(0,++q);
                }
                else
                {
                    q=c/2+s;
                    while (z!=makeMove(-1,-1))
                        makeMove(0,--q);
                }
            }
        }
    }
}

