#include<iostream>
#include<cstring>
#include<vector>
#include<set>
#include<map>
#include<cstdio>
#include<cstdlib>
#include<algorithm>
#include<cmath>
#include<queue>
using namespace std;
struct node
{
    int to,s;
    node() {};
    node(int _to, int _s)
    {
        to=_to;
        s=_s;
    }
};
int n,m,k;
vector<node> v[50005];
vector<int> ss;
int par[50005];
int find_par(int x)
{
    if(x==par[x]) return x;
    return par[x]=find_par(par[x]);
}
void read()
{
    int i,j,x,y,s;
    cin>>n>>m>>k;
    for(i=0;i<m;i++)
    {
        cin>>x>>y>>s;
        if(x!=y)
        {v[x].push_back(node(y,s));
        v[y].push_back(node(x,s));
        ss.push_back(s);
        }
    }
}
int idx;
void dfs(int x, int pr, int gr)
{
    //cout<<x<<" ";
    idx++;
    par[x]=idx;
    int i,j,sz;
    node nb;
    sz=v[x].size();
    for(i=0;i<sz;i++)
    {
        nb=v[x][i];
        if(nb.s<=gr||nb.to==pr)
            continue;
        if(!par[nb.to])
        {
            dfs(nb.to,x,gr);
        }
    }
    for(i=0;i<sz;i++)
    {
        nb=v[x][i];
        if(nb.s<=gr||nb.to==pr)
            continue;
        if(par[nb.to]<par[x])
        {
            par[x]=par[nb.to];
        }
    }
}
int check(int gr)
{
    int i,j;
    idx=0;
    dfs(1,1,gr);
    //cout<<endl;
    for(i=1;i<=n;i++)
    {
        if(!par[i])
        {
            return 0;
        }
    }
    int sz;
    node nb;
    int cnt=0;
    for(i=1;i<=n;i++)
    {
        sz=v[i].size();
        for(j=0;j<sz;j++)
        {
            nb=v[i][j];
            if(nb.s<=gr)
            {
                continue;
            }
            if(find_par(i)!=find_par(nb.to)&&v[i].size()>1)
            {
                cnt++;
                break;
            }
        }
    }
    for(i=1;i<=n;i++)
        cout<<par[i]<<" ";
    cout<<endl;
    cout<<cnt<<endl;
    return cnt;
}
int used[50005];
int ans=-1;
int check3(int x, int gr)
{
    queue<int> q;
    int i,j;
    node nb;
    int sz;
    int w;
    q.push(x==1?2:1);
    used[q.front()]=1;
    int cnt=0;
    while(!q.empty())
    {
        cnt++;
        w=q.front();
        q.pop();
        sz=v[w].size();
        for(i=0;i<sz;i++)
        {
            nb=v[w][i];
            if(nb.to==x||used[nb.to]||nb.s<=gr)
                continue;
            used[nb.to]=1;
            q.push(nb.to);
        }
    }
    if(cnt<n-1) return 1;
    return 0;
}
int check4(int gr)
{
    queue<int> q;
    int i,j;
    node nb;
    int sz;
    int w;
    q.push(1);
    int cnt=0;
    used[1]=1;
    while(!q.empty())
    {
        cnt++;
        w=q.front();
        q.pop();
        sz=v[w].size();
        for(i=0;i<sz;i++)
        {
            nb=v[w][i];
            if(used[nb.to]||nb.s<=gr)
                continue;
            used[nb.to]=1;
            q.push(nb.to);
        }
    }
    if(cnt!=n) return 0;
    return 1;
}
int check2(int gr, int l)
{
    int i,j;
    int cnt=0;
    for(i=1;i<=n;i++)
    {
        memset(used,0,sizeof(used));
        if(check3(i,gr))
        {
            cnt++;
            if(l==1) cout<<i<<" ";
        }
    }
    return cnt;
}
void solve()
{
    int l=-1,r=1e9+7,mid;
    int i,j;
    sort(ss.begin(),ss.end());
    int lol=0;
    for(i=0;i<ss.size();i++)
    {
        memset(used,0,sizeof(used));
        mid=ss[i];
        if(!check4(mid)) continue;
        lol=check2(mid,0);
        if(lol>=k)
        {
            cout<<mid<<" "<<lol<<endl;
            check2(mid,1);
            cout<<endl;
            return;
        }
    }
    cout<<-1<<" "<<0<<endl;
    return;
    /*while(l+1<r)
    {
        memset(par,0,sizeof(par));
        mid=(l+r)/2;
        cout<<"mid: "<<mid<<endl;
        int lol=check(mid);
        if(lol>=k||lol==0)
        {
            if(lol>0) ans=mid;
            r=mid;
        }
        else
        {
            l=mid;
        }
    }*/
}
int main()
{
	read();
	solve();
	return 0;
}
