#include<iostream>
#include<algorithm>
using namespace std;

void divide(string s, string &a1, string &b1, string &c1)
{
    int i;
    for(i=0; s[i]!='.' && i<s.size(); i++)
    {
        a1+=s[i];
    }
    for(i=i+1; s[i]!='(' && i<s.size(); i++)
    {
        b1+=s[i];
    }
    for(i=i+1; s[i]!=')' && i<s.size(); i++)
    {
        c1+=s[i];
    }
}

string fixA(string a)
{
    string rt="";
    bool flag=false;
    for(int i=0; i<a.size(); i++)
    {
        if(a[i]!='0')flag=true;
        if(flag)rt+=a[i];
    }
    return rt;
}

string fixB(string b, string c)
{
    if(c.size()>b.size())return b;
    string eq=b.substr(b.size()-c.size(), c.size());
    int cnt=b.size();
    if(eq==c)
    {
        cnt-=c.size();
        for(int curPos=b.size()-c.size()-c.size(); curPos>=0; curPos-=c.size())
        {
            string cur=b.substr(curPos, c.size());
            if(cur!=c)break;
            cnt-=c.size();
        }
    }
    return b.substr(0, cnt);
}

string fixC(string c)
{
    for(int i=1; i<=c.size(); i++)
    {
        string temp=c.substr(0, i);
        bool flag=true;
        for(int curPos=i; curPos<c.size(); curPos+=i)
        {
            string cur=c.substr(curPos, i);
            if(temp!=cur)
            {
                flag=false;
                break;
            }
        }
        if(flag)return temp;
    }
    return c;
}

void equalise(string &a, string &b, string& c)
{
    for(;;)
    {
        for(int i=0; i<c.size(); i++)
        {
            b+=c[i];
            if(b.size()==a.size())
            {
                c=c.substr(i, c.size()-i);
                return ;
            }
        }
    }
}

char parse(int c)
{
    if(c>=0 && c<=9)return (char)('0'+c);
    return (char)('A'+c-10);
}

string add(int base, string a, string b)
{
    int naum=0;
    string rt="";
    for(int i=b.size()-1; i>=0; i--)
    {
        rt=parse(((a[i]-'0')+(b[i]-'0')+naum)%base)+rt;
        naum=((a[i]-'0')+(b[i]-'0')+naum)/base;
    }
    return rt;
}

int main()
{
    string a1,b1,c1,a2,b2,c2;
    int b;
    string n1, n2;
    cin>>b>>n1>>n2;
    divide(n1, a1, b1, c1);
    divide(n2, a2, b2, c2);
    a1=fixA(a1);
    a2=fixA(a2);
    c1=fixC(c1);
    c2=fixC(c2);
    b1=fixB(b1,c1);
    b2=fixB(b2, c2);

    if(b1.size()<b2.size())
    {
        swap(a1, a2);
        swap(b1, b2);
        swap(c1, c2);
    }
   // cout<<a1<<" "<<b1<<" "<<c1<<endl;
   // cout<<a2<<" "<<b2<<" "<<c2<<endl;

    string d1=b1+c1;
    string d2=b2+c2;
    equalise(d1, d2, c2);

    int s1=c1.size(), s2=c2.size();
    int g=__gcd(s1, s2);
    int s=(s1*s2)/g;
    string co1=c1, co2=c2;
    for(int i=2; i<=s/s1; i++)
    {
        c1+=co1;
    }
    for(int i=2; i<=s/s2; i++)
    {
        c2+=co2;
    }
    if(a1.size()<a2.size())
    {
        swap(a1, a2);
        swap(b1, b2);
        swap(c1, c2);
    }
    int si2=a2.size();
    for(int i=1;i<=a1.size()-si2; i++)
    {
        a2="0"+a2;
    }
    //cout<<a1<<" "<<d1<<" "<<c1<<endl;
   // cout<<a2<<" "<<d2<<" "<<c2<<endl;
    cout<<add(b,a1,a2)<<"."<<add(b,d1,d2)<<"("<<add(b,c1,c2)<<")"<<endl;
    return 0;
}

/*
10
002.322(2111)
1242.31345363363363(363)
*/
