#include "hunter.h"

#include <iostream>
#include <vector>
#include <ctime>
#include <random>

using namespace std;

void startPlay1n(int i, int j){
    pair<int,int> enMove = makeMove(i,j);

    while(!(enMove.first == -1 && enMove.second == -1)){
        enMove = makeMove(enMove.first, enMove.second+1);
    }
}

void startPlay(int i, int j, const vector<vector<char> > &table,int n,int m){
     pair<int,int> enMove = makeMove(i,j);
    srand(time(NULL));
    while(!(enMove.first == -1 && enMove.second == -1)){
        int v,d;
        int x,y;
        do{
            v = rand() % 2;
            if(v==0)v=-1;
            d =  rand() % 2;
            if(d == 0){
                x=v;
                y=0;
            }else{
                y=v;
                x=0;
            }
        }while(!(x >= 0 && x < n && y >= 0 && y < m && table[enMove.first + x][enMove.second + y] == '.' ));
        enMove = makeMove(enMove.first + x, enMove.second + y);
    }
}

void play(int n, int m, const vector<vector<char> > &table){
    bool gameEnded = false;
    if(n==1){
        int a = 0;
        int st = 0;
        while(st < m){
            if(table[0][st] == '#'){
                st++;
                continue;
            }
            a = st+1;
            while(a < m && table[0][a] != '#'){
                //cout<<"Izbiram a="<<a<<endl;
                a++;
            }
            a--;
            if((a-st+1) % 2 == 1){
                //cout<<"Necheten broi kletki ot " << st << " do " << a <<endl;
                startPlay1n(0, st);
                return;
            }
            st = a+2;
        }
        startPlay1n(-1,-1);
    }else{
        for(int i = 0; i < n; i++){
            for(int j = 0; j < n; j++){
                if(table[i][j] != '#'){
                    startPlay(i,j, table,n,m);
                }
            }
        }
    }
}
