#include <iostream>
#include <vector>
#include <cstdio>
#define N 50003
#define M 200003
#include <algorithm>
using namespace std;
struct Edge
{
    int v,t;
    Edge(){}
    Edge(int v,int t):v(v),t(t){}
};
vector<Edge> g[N];
int n,m,k,snow[M],ans,fup[N],ent[N],gt,snqk;
bool svur,op[N],f[N];

bool ok(int v2)
{
    int br=0;
    for(Edge v3:g[v2])
    {
        if(v3.t>snqk) br++;
    }
    return br>1?1:0;
}

void dfs(int v=1,int p=0)
{
    fup[v]=ent[v]=gt++;
    f[v]=1;
   // cout<<v<< endl;
    for(Edge vr2 :g[v])
    {
        if(vr2.t<=snqk) continue;
        int v2=vr2.v;
        if(v2==p) continue;
        if(f[v2]) fup[v]=min(fup[v],ent[v2]);
        else
        {
            dfs(v2,v);
            fup[v]=min(fup[v],fup[v2]);
            if(ent[v] < fup[v2])
            {
                op[v]=1;
                if(ok(v2)) op[v2]=1;
            }
        }
    }

}

void findop(int snqk)
{
    svur=1;
    gt=0;
    ans=0;
    ::snqk=snqk;
    for(int i=1; i<=n; i++)
        op[i]=fup[i]=ent[i]=f[i]=0;
    dfs();
    if(gt<n) svur=0, ans=n;
    else for(int i=1; i<=n; i++) ans+=op[i];
   // cout<<snqk<<" "<<gt<<" "<<ans<< endl;
}

void solve()
{
    int l=-1,r=m-1,mid;
    while(r-l>1)
    {
        mid = (l+r)/2;
        findop(snow[mid]);
        //cout<<ans<<" "<<k<< endl;
        if(ans>=k) r=mid;
        else l=mid;
       // cout<<l<<" "<<r<< endl;
    }
    findop(snow[r]);
    if(!svur)
        {cout<<-1<<" "<<0<< endl; return;}
    cout<<snow[r]<<" "<<ans<< endl;
    for(int i=1; i<=n; i++)
        if(op[i])cout<<i<<" "; //               stranen izhod
    cout<< endl;
}

bool fff(Edge a,Edge b)
{
    if(a.v==b.v) return a.t>b.t;
    return a.v<b.v;
}

void input()
{
    cin>>n>>m>>k;
    vector<Edge> pom[N];
    int i,j,a,b,t;
    for(i=0; i<m; i++)
    {
        scanf("%i %i %i",&a,&b,&t);
        if(a==b) continue;
        pom[a].push_back(Edge(b,t));
        pom[b].push_back(Edge(a,t));
        snow[i]=t;
    }
    snow[m++]=0;
   // cout<<"hi"<< endl;
    for(i=1; i<=n; i++)
    {
        sort(pom[i].begin(),pom[i].end(),fff);
        for(j=0; j<pom[i].size(); j++)
        {
            g[i].push_back(pom[i][j]);
            while(j+1<pom[i].size() && pom[i][j].v==pom[i][j+1].v) j++;
        }
    }
   // cout<<"hi2"<< endl;
    sort(snow,snow+m);
}

int main()
{
    input();
    solve();
    return 0;
}
/*
8 13 3
1 2 19
1 3 13
2 3 5
4 2 9
2 5 7
3 5 17
6 3 8
3 8 12
4 7 11
5 7 5
7 2 10
7 6 13
8 5 16

3 3 1
1 2 42
2 3 42
1 3 666

*/
