#include "hunter.h"


#include<iostream>
#include<vector>
using namespace std;

pair<int, int> curr;


void evenLine(bool direction);
void oddLine(int x, int y);
int traps[128];
int trapindex=-1;


void play(int n, int m, const vector<vector<char> > &table)
{
    curr.first=0;
    curr.second=0;
    for(int i=0;i<m;i++)
    {
        if(table[0][i]=='#'){
            if(trapindex==-1)trapindex=0;
            traps[trapindex]=i;
            trapindex++;
        }
    }
    int zone=0;
    if(trapindex==-1)
    {
        if(m%2==1)
        {
            //cout<<1<<endl;
            oddLine(0,0);
            return;
        }
    }
    //check for odd lines//
    else
    if(trapindex>=0&&traps[0]>0)
    {
        zone=traps[0];
        if(zone%2==1)
        {oddLine(0,0);return;}
    }else {
            for(int i=1;i<trapindex; i++)
            {
                zone=traps[i]-traps[i-1]-1;
                if(zone%2==1)
                {
                    //cout<<2<<endl;
                    oddLine(0,traps[i-1]+1);
                    return ;
                }
            }
            if(trapindex>=0&&traps[trapindex-1]<m-1)
            {
                zone=m-1-traps[trapindex-1];
                if(zone%2==1)
                {
                    //cout<<3<<endl;
                    oddLine(0,traps[trapindex-1]+1);
                    return;
                }
            }
    }
    //if no odd lines
    //cout<<"make move"<<endl;
    curr=makeMove(-1,-1);
    if(curr.first==-1&&curr.second==-1)
    {
        return;
    }
    int firsti=-1;
    int secondi=-1;
    for(int i=curr.second;i>=0;i--)
    {
        if(table[0][i]=='#')firsti=i;
    }
    for(int i=curr.second;i<m;i++)
    {
        if(table[0][i]=='#')secondi=i;
    }
    if(firsti==-1){
        zone=curr.second;
        if(zone%2==1)
        {
            evenLine(0);
            return;
        }
        else
        {evenLine(1);}
    }
    else
        if((curr.second-firsti-1)%2==1)
        {
            evenLine(0);
        }
        else evenLine(1);
    if(secondi==-1)
    {
        zone=m-1-curr.second;
        if(zone%2==1)
        {
            evenLine(1);
            return;
        }
    }

}


void evenLine(bool direction)
{
    for(;;)
    {
        if(curr.first==-1&&curr.second==-1)break;
        if(direction==1)
        curr=makeMove(curr.first, curr.second+1);
        else
        curr=makeMove(curr.first, curr.second-1);
    }
}
void oddLine(int x, int y)
{
    curr=makeMove(x,y);
    for(;;)
    {
        if(curr.first==-1&&curr.second==-1)break;
        curr=makeMove(curr.first, curr.second+1);
    }
}
