#include <bits/stdc++.h>
#define REP(a,b) for(int i = (a); i < (b); i++)
#define REP2(a,b) for(int j = (a); j < (b); j++)
#define REP3(a,b) for(int k = (a); k < (b); k++)
#define all(x) (x).begin(),(x).end()
#define fi first
#define se second
#define pb push_back
#define mp make_pair
using namespace std;

typedef long long ll;
typedef pair<int,int> ii;
int N, M, K, best;
int G[1000][1000];
vector<vector<char> > T;
class uniFind{
public:
    int index[1001], sizes[1001];
    vector<ii> history;
    uniFind(){
        REP(0,1001)index[i] = i, sizes[i] = 1;
    }
    int root(int i){
        while(i!=index[i])i = index[i] = index[index[i]];
        return i;
    }
    bool areCon(int a, int b){
        return root(a) == root(b);
    }
    bool unite(int a, int b){
        a = root(a);
        b = root(b);
        if(a==b)return (sizes[a] == N || sizes[b] == N);
        if(sizes[a] > sizes[b])sizes[a]+=sizes[b], index[b] = a;
        else sizes[b]+=sizes[a], index[a] = b;
        return (sizes[a] == N || sizes[b] == N);
    }
    void qUnite(int a, int b){
        a = root(a);
        b = root(b);
        index[b] = a;
        history.pb(mp(a,b));
    }
};
struct edge{
    int a, b, s;
    edge(int a, int b, int s){
        this->a = a;
        this->b = b;
        this->s = s;
    }
};
vector<edge> E;
bool help(edge &a, edge &b){
    return a.s < b.s;
}
int used[1001], id = 1;
bool bfs(int k){
    int ans = 1;
    queue<int> Q;
    Q.push((k==1?2:1));
    used[(k==1?2:1)] = id;
    while(!Q.empty()){
        ans++;
        int n = Q.front();
        Q.pop();
        REP(1,N+1){
            if(i==k)continue;
            if(used[i]==id)continue;
            if(!G[n][i])continue;
            Q.push(i);
            used[i] = id;
        }
    }
    return ans == N;
}
vector<int> crit;
bool alreadyCrit[1001];
int checkorCritical(){
    crit.clear();
    int res = 0;
    for(int i = 1; i <= N; i++){
        if(alreadyCrit[i]){
            crit.pb(i);
            continue;
        }
        if(!bfs(i)){
            crit.pb(i);
            alreadyCrit[i] = 1;
        }
        id++;
    }
    return crit.size();
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> N >> M >> K;
    best = M;
    REP(0,M){
        int a, b, c;
        cin >> a >> b >> c;
        G[a][b] = c;
        G[b][a] = c;
        E.pb(edge(a,b,c));
    }
    sort(all(E), help);
    uniFind U;
    for(int i = E.size()-1; i >= 0; i--){
        int temp = E[i].s, ind = i;
        bool cool = 0;
        while(E[i].s == temp){
            if(U.unite(E[i].a,E[i].b))cool = 1;
            i--;
        }
        i++;
        if(cool){
            best=i;
            break;
        }
    }
    REP(0,best){
        int temp = E[i].s;
        while(E[i].s == temp){
            G[E[i].a][E[i].b] = 0;
            G[E[i].b][E[i].a] = 0;
            i++;
        }
        i--;

        if(checkorCritical() >= K){
            cout << temp << " " << crit.size() << endl;
            REP2(0,crit.size())cout << crit[j] << " ";
            cout << endl;
            return 0;
        }
    }
    cout << -1 << " " << 0 << endl;
}
/*
8 13 3
1 2 19
1 3 13
2 3 5
4 2 9
2 5 7
3 5 17
6 3 8
3 8 12
4 7 11
5 7 5
7 2 10
7 6 13
8 5 16
*/
