#include <cstdio>
#include <iostream>
#include <vector>
#include <cstring>
#include <utility>
#include <queue>
#include <algorithm>
//#include <ctime>

#define prev abcd

using namespace std;

//clock_t tStart; void startClock(){tStart=clock();}void printClock(){printf("%.3f\n", (clock()-tStart)/(CLOCKS_PER_SEC*1.0));}

int n, m, k, a, b, c, csnow, topq, block, prev;

vector<pair<int, int> > v[50002];
vector<int> ans;
priority_queue<int> q;
queue<int> bfsq;
bool used[50002], usedans[50002];

void bfs(int curr)
{
    if(usedans[curr]) return;
    block=curr;
    memset(used, 0, sizeof used);
    while(!bfsq.empty()) bfsq.pop();
    if(curr==1) curr=2;
    else curr=1;
    used[curr]=1;
    bfsq.push(curr);
    while(!bfsq.empty())
    {
        topq=bfsq.front();
        bfsq.pop();
        for(pair<int, int> j:v[topq])
        {
            if(j.second<=csnow || j.first==block) continue;
            if(!used[j.first])
            {
                used[j.first]=1;
                bfsq.push(j.first);
            }
        }
    }
    for(int j=1; j<=n; ++j)
    {
        if(!used[j] && j!=block)
        {
            ans.push_back(block);
            usedans[block]=1;
            //printf("%d is not reached by %d block %d\n", j, curr, block);
            break;
        }
    }
}

bool prebfs()
{
    int curr;
    for(curr=1; curr<=n; ++curr)
    {
        if(!usedans[curr])
        {
            break;
        }
    }
    memset(used, 0, sizeof used);
    while(!bfsq.empty()) bfsq.pop();
    used[curr]=1;
    bfsq.push(curr);
    while(!bfsq.empty())
    {
        topq=bfsq.front();
        bfsq.pop();
        for(pair<int, int> j:v[topq])
        {
            if(j.second<=csnow) continue;
            if(!used[j.first])
            {
                used[j.first]=1;
                bfsq.push(j.first);
            }
        }
    }
    for(int j=1; j<=n; ++j)
    {
        if(!used[j])
        {
            return true;
        }
    }
    return false;
}

int main ()
{
    //freopen("i11.txt", "r", stdin);
    scanf("%d %d %d", &n, &m, &k);
    for(int i=0; i<m; ++i)
    {
        scanf("%d %d %d", &a, &b, &c);
        v[a].push_back({b, c});
        v[b].push_back({a, c});
        q.push(-c);
    }
    memset(usedans, 0, sizeof usedans);
    prev=-1;
    for(; !q.empty(); )
    {
        if((int)ans.size()>=k) break;
        csnow=-q.top();
        q.pop();
        if(prev==csnow) continue;
        if(!prebfs())
        {
            for(int i=1; i<=n; ++i)
            {
                bfs(i);
            }
        }
        prev=csnow;
    }
    if((int)ans.size()==0)
    {
        printf("-1 0\n");
        return 0;
    }
    printf("%d %d\n", csnow, (int)ans.size());
    sort(ans.begin(), ans.end());
    for(int i:ans) printf("%d ", i);
    printf("\n");
    return 0;
}
