#include <cstdio>
#include <iostream>
#include <vector>
#include <cstring>
#include <utility>
#include <queue>
#include <algorithm>
//#include <ctime>

#define prev abcd

using namespace std;

//clock_t tStart; void startClock(){tStart=clock();}void printClock(){printf("%.3f\n", (clock()-tStart)/(CLOCKS_PER_SEC*1.0));}

int n, m, k, a, b, c, csnow, topq, block, prev, rsnow=(int)(1e9+1);

vector<pair<int, int> > v[50002];
vector<int> ans, q, rans;
queue<int> bfsq;
bool used[50002], usedans[50002];

void bfs(int curr)
{
    if(usedans[curr]) return;
    block=curr;
    memset(used, 0, sizeof used);
    while(!bfsq.empty()) bfsq.pop();
    if(curr==1) curr=2;
    else curr=1;
    used[curr]=1;
    bfsq.push(curr);
    while(!bfsq.empty())
    {
        topq=bfsq.front();
        bfsq.pop();
        for(pair<int, int> j:v[topq])
        {
            if(j.second<=csnow || j.first==block) continue;
            if(!used[j.first])
            {
                used[j.first]=1;
                bfsq.push(j.first);
            }
        }
    }
    for(int j=1; j<=n; ++j)
    {
        if(!used[j] && j!=block)
        {
            ans.push_back(block);
            usedans[block]=1;
            //printf("%d is not reached by %d block %d\n", j, curr, block);
            break;
        }
    }
}

bool prebfs()
{
    int curr;
    for(curr=1; curr<=n; ++curr)
    {
        if(!usedans[curr])
        {
            break;
        }
    }
    memset(used, 0, sizeof used);
    while(!bfsq.empty()) bfsq.pop();
    used[curr]=1;
    bfsq.push(curr);
    while(!bfsq.empty())
    {
        topq=bfsq.front();
        bfsq.pop();
        for(pair<int, int> j:v[topq])
        {
            if(j.second<=csnow) continue;
            if(!used[j.first])
            {
                used[j.first]=1;
                bfsq.push(j.first);
            }
        }
    }
    for(int j=1; j<=n; ++j)
    {
        if(!used[j])
        {
            return true;
        }
    }
    return false;
}

int main ()
{
    //freopen("i11.txt", "r", stdin);
    scanf("%d %d %d", &n, &m, &k);
    for(int i=0; i<m; ++i)
    {
        scanf("%d %d %d", &a, &b, &c);
        v[a].push_back({b, c});
        v[b].push_back({a, c});
        q.push_back(c);
    }
    sort(q.begin(), q.end());
    int l=0, r=m-1, mid;
    while(l<=r)
    {
        mid=(l+r+1)>>1;
        csnow=q[mid];
        ans.clear();
        memset(usedans, 0, sizeof usedans);
        if(!prebfs())
        {
            for(int i=1; i<=n; ++i)
            {
                bfs(i);
            }
        }
        else {r=mid-1;continue;}
        if((int)ans.size()<k) l=mid+1;
        else
        {
            r=mid-1;
            if(rsnow>csnow)
            {
                rsnow=csnow;
                rans.clear();
                for(int i:ans) rans.push_back(i);
            }
        }
    }
    if((int)rans.size()==0)
    {
        printf("-1 0\n");
        return 0;
    }
    printf("%d %d\n", rsnow, (int)rans.size());
    sort(rans.begin(), rans.end());
    for(int i:rans) printf("%d ", i);
    printf("\n");
    return 0;
}
