#include <cstdio>
#include <algorithm>
#include <cstring>

using namespace std;

//clock_t tStart; void startClock(){tStart=clock();}void printClock(){printf("%.3f\n", (clock()-tStart)/(CLOCKS_PER_SEC*1.0));}

int b, sfull1=0, sfull2=0, sready, idx, h=0, sp1=0, sp2=0;
bool fl;

char one[2048], two[2048];
int pointIdx[2], full1[2048], full2[2048], ready[2048], point1[2048], point2[2048], pready[2048], good[2048];

int numb(char ch)
{
    if(ch>='A') return ch-'A'+10;
    return ch-'0';
}

void part1(char *arr, int arr1[], int &sizearr1)
{
    fl=false;
    for(int i=0; i<strlen(arr); ++i)
    {
        if(arr[i]=='.')
        {
            fl=true;
            idx=i;
            pointIdx[h++]=i;
            break;
        }
    }
    if(!fl) idx=strlen(arr);
    for(int i=idx-1; i>=0; --i)
    {
        arr1[sizearr1++]=numb(arr[i]);
    }
}

void add(int arr1[], int arr2[], int addd[], int &saddd)
{
    int pr=0;
    for(int i=0; i<2048; ++i)
    {
        addd[i]=arr1[i]+arr2[i]+pr;
        pr=0;
        if(addd[i]>=b)
        {
            pr=1;
            addd[i]-=b;
        }
    }
    for(int i=2047; i>=0; --i)
    {
        if(addd[i]!=0)
        {
            saddd=i+1;
            break;
        }
    }
}

void part2()
{
    if(pointIdx[0]!=0)
    {
        for(idx=pointIdx[0]+1; idx<strlen(one); ++idx)
        {
            if(one[idx]=='(') break;
            point1[sp1++]=numb(one[idx]);
        }
        idx++;
        for(int kk=0; kk<(max(strlen(one)-pointIdx[0], strlen(two)-pointIdx[1])+2)/(strlen(one)-1-idx); ++kk)
        {
            for(int j=idx; one[j]!=')'; ++j)
            {
                point1[sp1++]=numb(one[j]);
            }
        }
    }
    else sp1=1002;
    if(pointIdx[1]!=0)
    {
        for(idx=pointIdx[1]+1; idx<strlen(two); ++idx)
        {
            if(two[idx]=='(') break;
            point2[sp2++]=numb(two[idx]);
        }
        idx++;
        for(int kk=0; kk<(max(strlen(one)-pointIdx[0], strlen(two)-pointIdx[1])+2)/(strlen(two)-1-idx); ++kk)
        {
            for(int j=idx; two[j]!=')'; ++j)
            {
                point2[sp2++]=numb(two[j]);
            }
        }
    }
    else sp2=1002;
}

void xreverse(int arr[], int sarr)
{
    int xx, yy;
    for(int i=0; i<sarr; ++i)
    {
        xx=i;
        yy=sarr-1-i;
        swap(arr[xx], arr[yy]);
        if(xx>=yy) break;
    }
}

int main ()
{
    //freopen("i3.txt", "r", stdin);
    scanf("%d", &b);
    scanf("%s", one);
    scanf("%s", two);
    part1(one, full1, sfull1);
    part1(two, full2, sfull2);
    add(full1, full2, ready, sready);
    part2();
    int smth;
    if(sp1>sp2)
    {
        smth=sp1-sp2;
        for(int i=0; i<smth; ++i)
        {
            point2[sp2++]=0;
        }
    }
    else
    if(sp2>sp1)
    {
        smth=sp2-sp1;
        for(int i=0; i<smth; ++i)
        {
            point1[sp1++]=0;
        }
    }
    xreverse(point1, sp1);
    xreverse(point2, sp2);
    add(point1, point2, pready, h);
    for(int i=sready-1; i>=0; --i)
    {
        printf("%d", ready[i]);
    }
    printf("\n");
    return 0;
}
