# include <iostream>
# include <cmath>
# include <vector>
# include "hunter.h"

using namespace std;

void play(int n, int m, const vector<vector<char> > &table)
{
	int i, j, tl, tr, fl = 0;
	pair <int, int> mm;
	vector <int> v;
	
	for (i = 0; i < m; i ++)
		v.push_back (table[0][i]);
	
	for (i = 0; i < m; i ++)
	{
		if (v[i] == '#')
			continue;
		tl = tr = 0;
		for (j = i - 1; j >= 0; j --)
		{
			if (v[j] == '#')
				break;
			tl ++;
		}
		
		for (j = i + 1; j < m; j ++)
		{
			if (v[j] == '#')
				break;
			tr ++;
		}
		
		if ((tl & 1) || (tr & 1))
			continue;
		
		mm = makeMove (0, j);
		
		
		if (mm.first == -1)
			return;
		v[j] = '#';
		v[mm.second] = '#';
		
		while (1)
		{
			if (mm.first == -1)
				return;
				v[mm.second] = '#';
			if (mm.second + 1 < m && v[mm.second + 1] != '#')
			{
			v[mm.second + 1] = '#';
				mm = makeMove (0, mm.second + 1);
				continue;
			}
			if (mm.second && v[mm.second - 1] != '#')
			{
			v[mm.second - 1] = '#';
				mm = makeMove (0, mm.second - 1);
				continue;
			}
		}
		return;
	}
	
	mm = makeMove (-1, -1); 
	
	if (mm.first == -1)
		return;
	
	v[mm.first][mm.second] = '#';
	
	tl = tr = 0;
	
	for (j = mm.second - 1; j >= 0; j --)
	{
		if (v[j] == '#')
			break;
		tl ++;
	}
		
	for (j = mm.second + 1; j < m; j ++)
	{
		if (v[j] == '#')
			break;
		tr ++;
	}
	
	if (tl & 1)
	{
		v[mm.second - 1] = '#';
	
		mm = makeMove (0, mm.second - 1);
	}
	else
	{
			v[mm.second + 1] = '#';

		mm = makeMove (0, mm.second + 1);
	}
	while (1)
	{
		if (mm.first == -1)
			return;
		if (mm.second + 1 < m && v[0][mm.second + 1] != '#')
		{
			mm = makeMove (0, mm.second + 1);
			continue;
		}
		if (mm.second && v[0][mm.second - 1] != '#')
		{
			mm = makeMove (0, mm.second - 1);
			continue;
		}
	}
	return;
}

