#include "hunter.h"
#include <bits/stdc++.h>

#ifdef LOCAL
    #include "Lgrader.cpp"
#endif

using namespace std;

const int N = 107;

int n,m;
char a[N][N];

void play(int n_pass, int m_pass, const vector < vector < char > > &table_pass) {
    int i,j,cnt=0,start=-1;
    pair < int, int > their;

    n=n_pass;
    m=m_pass;
    
    for(i=0;i<n;i++) {
        for(j=0;j<m;j++) {
            a[i][j]=table_pass[i][j];
        }
    }

    //Only handle N = 1
    for(j=0;j<m;j++) {
        if(a[0][j]=='.') {
            if(cnt==0) {
                start=j;
                ++cnt;
            }
            else {
                ++cnt;
            }
        }
        else {
            if(cnt%2==1) {
                //Just start at start
                while((their=makeMove(0,start))!=make_pair(-1,-1)) {
                    start+=2;
                }
                return;
            }
            cnt=0;
            start=-1;
        }
    }

    //Since there is no chunk with odd size, let them play first
    their=makeMove(-1,-1);
    if(their==make_pair(-1,-1)) return;

    a[their.first][their.second]='#';
    for(j=0;j<m;j++) {
        if(a[0][j]=='.') {
            if(cnt==0) {
                start=j;
                ++cnt;
            }
            else {
                ++cnt;
            }
        }
        else {
            if(cnt%2==1) {
                if(their.second+1==start) {
                    //Just start at start
                    while((their=makeMove(0,start))!=make_pair(-1,-1)) {
                        start+=2;
                    }
                    return;
                }
                else {
                    //Just start at end
                    start+=cnt;
                    while((their=makeMove(0,start))!=make_pair(-1,-1)) {
                        start-=2;
                    }
                    return;
                }
            }
            cnt=0;
            start=-1;
        }
    }
}
