#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const unsigned long long B = 137;

int b;
string s,i1,f1,p1,i2,f2,p2;
string ansp,ansf,ansi;
int carryp,carryf;
unsigned long long pw[1000007];
char save_to_b[1000];
int save_to_dec[1000];
//map < int, int > save_to_dec;

inline char to_b(int x) {
    //if(x<=9) return x+'0';
    //return 'A'+x-10;
    return save_to_b[x];
}

inline int to_dec(char a) {
    return (int)save_to_dec[(int)(a)];
    //if(a<='9') return a-'0';
    //return 10+a-'A';
}

void go() {
    for(int x=0;x<=36;x++) {
        char c;
        if(x<=9) c=x+'0';
        else c='A'+x-10;
        //cout<<(int)(c)<<endl;
        save_to_b[x]=c;
        //save_to_dec[(int)(c)]=x;
    }
    for(char c='0';c<='9';c++) {
        save_to_dec[(int)(c)]=c-'0';
    }
    for(char c='A';c<='Z';c++) {
        save_to_dec[(int)(c)]=10+c-'A'; 
    }
    save_to_dec[(int)('(')]=100;
    save_to_dec[(int)('.')]=100;
    save_to_dec[(int)(')')]=100;
}

unsigned long long get_hash(vector < unsigned long long > &a, int l, int r) {
    return a[r]-((l==0) ? 0 : a[l-1])*pw[r-l+1];
}

void parse(string a, string &i, string &f, string &p) {
    int j;

    i.clear();
    f.clear();
    p.clear();

    for(j=0;j<(int)(a.size());j++) {
        if(to_dec(a[j])>=0 && to_dec(a[j])<=b-1) i.push_back(a[j]);
        else break;
    }

    for(j=0;j<(int)(a.size());j++) if(a[j]=='.') break;
    if(j<(int)(a.size())) {
        for(++j;j<(int)(a.size());j++) {
            if(to_dec(a[j])>=0 && to_dec(a[j])<=b-1) f.push_back(a[j]);
            else break;
        }
    }

    for(j=0;j<(int)(a.size());j++) if(a[j]=='(') break;
    if(j<(int)(a.size())) {
        for(++j;j<(int)(a.size());j++) {
            if(to_dec(a[j])>=0 && to_dec(a[j])<=b-1) p.push_back(a[j]);
            else break;
        }
    }

    if(p.empty()) p="0";
}

bool cmp(string &a, int l1, int r1, int l2, int r2) {
    for(int i=l1,j=l2;i<=r1;i++,j++) {
        if(a[i]!=a[j]) return false;
    }
    return true;
}

bool cmp(vector < unsigned long long > &a, int l1, int r1, int l2, int r2) {
    return get_hash(a,l1,r1)==get_hash(a,l2,r2);
}

bool cmp(string &a, int l1, int r1, string &b, int l2, int r2) {
    for(int i=l1,j=l2;i<=r1;i++,j++) {
        if(a[i]!=b[j]) return false;
    }
    return true;
}

//May need hash?!
bool has_period(vector < unsigned long long > &a, int len) {
    if(a.size()%len) return false;
    for(int i=len;i<(int)(a.size());i+=len) {
        if(!cmp(a,0,len-1,i,i+len-1)) return false;
    }
    return true;
}

int gcd(int a, int b) {
    int r;
    while(b) r=a%b,a=b,b=r;
    return a;
}

int lcm(int a, int b) {
    return a*b/gcd(a,b);
}

void find_period() {
    vector < unsigned long long > ph;
    unsigned long long h;
    int len=lcm(p1.size(),p2.size());
    //string x1=p1,x2=p2;
    int i,idx1=(int)(p1.size())-1,idx2=(int)(p2.size())-1;

    /*while(x1.size()!=x2.size()) {
        if(x1.size()<x2.size()) {
            x1+=p1;
        }
        else {
            x2+=p2;
        }
    }*/

    carryp=0;
    //ansp.resize(x1.size());
    ansp.resize(len);
    for(i=(int)(ansp.size())-1;i>=0;i--) {
        int curr=to_dec(p1[idx1])+to_dec(p2[idx2])+carryp;
        if(--idx1<0) idx1=(int)(p1.size())-1;
        if(--idx2<0) idx2=(int)(p2.size())-1;
        carryp=curr/b;
        curr%=b;
        ansp[i]=to_b(curr);
    }
    for(i=(int)(ansp.size())-1;i>=0;i--) {
        int curr=to_dec(p1[idx1])+to_dec(p2[idx2])+carryp;
        if(--idx1<0) idx1=(int)(p1.size())-1;
        if(--idx2<0) idx2=(int)(p2.size())-1;
        carryp=curr/b;
        curr%=b;
        ansp[i]=to_b(curr);
    }

    h=0;
    for(i=0;i<(int)(ansp.size());i++) {
        h*=B;
        h+=to_dec(ansp[i]);
        ph.push_back(h);
    }

    //Try to minimize period:
    for(i=1;i<(int)(ansp.size());i++) if(has_period(ph,i)) {
        ansp.resize(i);
        return;
    }
}

void find_float() {
    int x1=f1.size(),x2=f2.size();
    int i;
    
    carryf=carryp;

    while(x1!=x2) {
        if(x1<x2) {
            x1+=p1.size();
        }
        else {
            x2+=p2.size();
        }
    }

    ansf.resize(x1);
    for(i=(int)(ansf.size())-1;i>=0;i--) {
        int a1,a2;
        if(i<(int)(f1.size())) a1=to_dec(f1[i]);
        else a1=to_dec(p1[(i-f1.size())%p1.size()]);
        if(i<(int)(f2.size())) a2=to_dec(f2[i]);
        else a2=to_dec(p2[(i-f2.size())%p2.size()]);
        int curr=(a1+a2+carryf);
        //int curr=to_dec(x1[i])+to_dec(x2[i])+carryf;
        carryf=curr/b;
        curr%=b;
        ansf[i]=to_b(curr);
    }

    //Remove period suffixes
    while(ansf.size()>=ansp.size()) {
        if(cmp(ansf,ansf.size()-ansp.size(),ansf.size()-1,ansp,0,ansp.size()-1)) {
            ansf.resize(ansf.size()-ansp.size());
        }
        else {
            break;
        }
    }

    int mx=0;
    for(i=0;i<(int)(ansp.size()) && i<(int)(ansf.size());i++) {
        if(ansp[ansp.size()-i-1]==ansf[ansf.size()-i-1]) ++mx;
        else break;
    }

    for(i=0;i<mx;i++) ansp.pop_back();

    reverse(ansp.begin(),ansp.end());
    
    for(i=0;i<mx;i++) {
        //ansp.pop_back();
        ansp.push_back(ansf.back());
        ansf.pop_back();
    }
    reverse(ansp.begin(),ansp.end());
}

void find_integer() {
    int i,curr,carry=carryf;

    reverse(i1.begin(),i1.end());
    reverse(i2.begin(),i2.end());
    while(i1.size()>i2.size()) i2.push_back('0');
    while(i1.size()<i2.size()) i1.push_back('0');
    
    for(i=0;i<(int)(i1.size());i++) {
        curr=to_dec(i1[i])+to_dec(i2[i])+carry;
        carry=curr/b;
        curr%=b;
        ansi.push_back(to_b(curr));
    }
    if(carry) ansi.push_back(to_b(carry));

    reverse(i1.begin(),i1.end());
    reverse(i2.begin(),i2.end());
    reverse(ansi.begin(),ansi.end());
}

void remove_trailing_zeroes(string &s) {
    while(!s.empty() && s.back()=='0') s.pop_back();
}

void remove_leading_zeroes(string &s) {
    reverse(s.begin(),s.end());
    remove_trailing_zeroes(s);
    reverse(s.begin(),s.end());
}

void add1() {
    int carry=1,i;
    for(i=(int)(ansf.size())-1;i>=0 && carry;i--) {
        int curr=to_dec(ansf[i])+carry;
        carry=curr/b;
        curr%=b;
        ansf[i]=to_b(curr);
    }
    if(carry==0) return;
    reverse(ansi.begin(),ansi.end());
    for(i=0;i<(int)(ansi.size()) && carry;i++) {
        int curr=to_dec(ansi[i])+carry;
        carry=curr/b;
        curr%=b;
        ansi[i]=to_b(curr);
    }
    if(carry) ansi.push_back(to_b(carry));
    reverse(ansi.begin(),ansi.end());
}

void print(string i, string f, string p) {
    cout<<i;
    if(f.empty() && p.empty()) return;
    cout<<'.'<<f;
    if(!p.empty()) cout<<'('<<p<<')';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    go();

    pw[0]=1;
    for(int i=1;i<1000007;i++) pw[i]=pw[i-1]*B;

    cin>>b;
    cin>>s;
    parse(s,i1,f1,p1);
    cin>>s;
    parse(s,i2,f2,p2);

    find_period();

    find_float();

    find_integer();

    if(ansp.size()==1) { //Period has only one digit
        if(to_dec(ansp[0])==0) {
            ansp.clear();
        }
        else if(to_dec(ansp[0])==b-1) {
            add1();
            ansp.clear();
        }
    }

    if(ansp.empty()) {
        remove_trailing_zeroes(ansf);
    }

    remove_leading_zeroes(ansi);
    if(ansi.empty()) ansi="0";

    print(ansi,ansf,ansp);
    cout<<endl;

    return 0;
}
