#include <iostream>
#include <vector>
#include <list>
#include <set>
using namespace std;

using Graph = vector<list<pair<int,int>>>;
Graph g;
void inp(int n, int m)
{
    g.resize(n);
    int from, to, sn;
    while(m--)
    {
        cin >> from >> to >> sn;
        g[from-1].emplace_back(to-1,sn);
        g[to-1].emplace_back(from-1,sn);
    }
}

vector<bool> f;
set<int> dang;
void DFS(int start)
{
    f[start]=true;
    for(auto&& v: g[start]) if(!f[v.first]) DFS(v.first);
}

void init(int n)
{
    for(int i=0; i<n; ++i) f[i]=false;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n,m,k;
    cin >> n >> m >> k;
    f.resize(n);
    inp(n,m);
    for(int i=1;; ++i)
    {
        init(n);
        for(auto&& l: g)
            for(auto it=l.begin(); it!=l.end();)
            {
                if(it->second<=i) l.erase(it++);
                else ++it;
            }
        DFS(0);
        for(bool b: f) if(!b)
        {
            cout << "-1 0\n";
            return 0;
        }
        for(int i=0; i<n; ++i)
        {
            for(int j=0; j<n; ++j)
            {
                init(n);
                f[i]=true;
                if(i==j) continue;
                DFS(j);
                for(int k=0; k<f.size(); ++k)
                    if(!f[k]) dang.insert(i);
            }

        }
        if(dang.size()>=k)
        {
            cout << i << ' ' << dang.size() << endl;
            auto it=dang.begin();
            cout << *it+1;
            for(++it; it!=dang.end(); ++it) cout << ' ' << *it+1;
            cout << endl;
            /*for(size_t j=0; j<dang.size()-1; ++j) cout << dang[j] << ' ';
            cout << dang[dang.size()-1] << endl;*/
            return 0;
        }
        dang.clear();
    }
}

/**
8 13 3
1 2 19
1 3 13
2 3 5
4 2 9
2 5 7
3 5 17
6 3 8
3 8 12
4 7 11
5 7 5
7 2 10
7 6 13
8 5 16

3 3 1
1 2 42
2 3 42
1 3 666
*/
