#include <vector>
#include <utility>
#include "hunter.h"

using namespace std;

void play (int n, int m, const vector < vector < char > >& table)
{
	if (table.size () == 1)
	{
		vector < pair < int, int > > seqs;
		int start = 0;
		for (int i = 0 ; i < table [0].size () ; i ++)
		{
			if (table [0][i] == '#')
			{
				if (start != i)
					seqs.push_back ({start, i - 1});
				start = i + 1;
			}
			else if (i == table [0].size () - 1)
			{
				seqs.push_back ({start, i});
			}
		}
		for (auto& x : seqs)
			if ((x.second - x.first + 1) % 2 == 1)
			{
				//cout << x.first << " " << x.second << endl;
				auto curr = makeMove (0, x.first);
				while (curr != make_pair (-1, -1))
				{
					//cout << 0 << " " << curr.second + 1 << endl;
					curr = makeMove (0, curr.second + 1);
				}
				return;
			}
		auto curr = makeMove (-1, -1);
		//cout << "makeMove (-1, -1) has been called" << endl;
		for (auto& x : seqs)
			if (x.first <= curr.second and curr.second <= x.second)
			{
				if (((curr.second - 1) - x.first + 1) % 2 == 1)
				{
					//cout << x.first << " " << x.second << endl;
					while (curr != make_pair (-1, -1))
					{
						//cout << 0 << " " << curr.second - 1 << endl;
						curr = makeMove (0, curr.second - 1);
					}
					return;
				}
				else if ((x.second - (curr.second + 1) + 1) % 2 == 1)
				{
					//cout << "detected range: " << x.first << " " << x.second << endl;
					//cout << "curr pos: " << curr.second << endl;
					while (curr != make_pair (-1, -1))
					{
						//cout << "my_move: " << 0 << " " << curr.second + 1 << endl;
						curr = makeMove (0, curr.second + 1);
					}
					return;
				}
			}
		//for (auto& x : seqs)
			//cout << x.first << " " << x.second << endl;
	}
	//cout << "fail\n";
	return;
}
