#include "hunter.h"
#include <vector>
using namespace std;

void play(int n, int m, const vector<vector<char> > &table)
{
    /// SUBTASK 1
    if(n == 1)
    {
        int counter = 0;

        pair<int, int> pos;
        int i;
        bool moved = false;
        for(i = 0; i < m; i++)
        {
            if(table[0][i] == '#')
            {

                if(counter % 2 == 1)
                {
                    pos = makeMove(0,i-1);
                    if(pos.first == -1 && pos.second == -1)
                        return;
                    moved = true;
                }
                counter = 0;


            }
            else
            {
                counter++;
            }
        }
        if(!moved)
        {
            if(counter % 2 == 1)
            {
                pos = makeMove(0,m-1);
                if(pos.first == -1 && pos.second == -1)
                    return;
            }
            else
            {
                /// judge is first
                pos = makeMove(-1,-1);
                int j = pos.second;

                /// determine direction
                bool right = false;
                while(true)
                {
                    if(j+1<m-1 && table[0][j+1] == '.')
                    {
                        right = !right;
                        j++;
                    }
                    else
                    {
                        break;
                    }
                }

                while(true)
                {
                    if(pos.first == -1 && pos.second == -1)
                        return;
                    j = pos.second;
                    if(right)
                    {
                        pos = makeMove(0,j+1);
                    }
                    else
                    {
                        pos = makeMove(0,j-1);
                    }
                }
            }
        }
        /// we are first
        while(true)
        {
            if(pos.first == -1 && pos.second == -1)
                return;
            int j = pos.second;
            pos = makeMove(0,j-1);
        }
    }
    else
    {
        pair<int,int> pos;
        while(true)
        {
            if(pos.first == -1 && pos.second == -1)
                return;

            pos = makeMove(0,0);
        }
    }
}

