#include "hunter.h"
#include <vector>
#include <iostream>
#define fi first
#define se second
using namespace std;

//pair<int, int> makeMove(int x, int y)
//{
//    cout << x << ' ' << y << endl;
//    cin >> x >> y;
//    return make_pair(x, y);
//}

void play(int n, int m, const vector<vector<char>> &table)
{
    if (n == 1)
    {
        vector<pair<int, int>> v;
        bool special = true;
        int odd = -1;
        for (int i = 0; i < m; ++ i)
        {
            if (table[0][i] == '.') special = false;
            if (table[0][i] == '.' and (i == 0 or table[0][i - 1] == '#'))
            {
                int f = i, l = i;
                while (l + 1 < m and table[0][l + 1] == '.') l++;
                v.emplace_back(f, l);
                if ((l - f) % 2 == 0) odd = v.size() - 1;
            }
        }

        if (special)
        {
            makeMove(-1, -1);
            return;
        }
        if (odd != -1)
        {
            auto r = makeMove(0, v[odd].fi);
            while (r.fi != -1 and r.se != -1)
            {
                r = makeMove(r.fi, r.se + 1);
            }
        }
        else
        {
            auto r = makeMove(-1, -1);

            int f = r.se;
            while (f - 1 >= 0 and table[0][f - 1] == '.') f--;

            if ((r.se - f) % 2 == 0)
            {
                while (r.fi != -1 and r.se != -1)
                {
                    r = makeMove(r.fi, r.se + 1);
                }
            }
            else
            {
                while (r.fi != -1 and r.se != -1)
                {
                    r = makeMove(r.fi, r.se - 1);
                }
            }
        }
    }
}
//
//
//int main()
//{
//    int n = 1, m;
//
//    vector<char> v;
//    vector<vector<char>> t;
//
//    cin >> m;
//    for (int i = 1; i <= m; ++ i)
//    {
//        char ch;
//        cin >> ch;
//        v.push_back(ch);
//    }
//
//    t.push_back(v);
//
//    play(n, m, t);
//
//}
