#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
using namespace std;

vector <int> a,b,c,d,res,ratres,realres;
int base;
string s1,s2,partans;
bool fl;

int Digit(char ch)
{
  if(ch>='0' && ch<='9')
   return ch-'0';

 return 10+(ch-'A');
}

char Character(int digit)
{
  if(digit>=0 && digit<=9)
   return digit+'0';

 return (digit-10)+'A';
}

void FindSum()
{
 int i,carry=0,len,sum;

 len=min(a.size(),b.size());
  for(i=0;i<len;i++)
  {
   sum=a[i]+b[i]+carry;
   res.push_back(sum%base);
   carry=sum/base;
  }

  for(i=len;i<a.size();i++)
  {
   sum=a[i]+carry;
   res.push_back(sum%base);
   carry=sum/base;
  }

  for(i=len;i<b.size();i++)
  {
   sum=b[i]+carry;
   res.push_back(sum%base);
   carry=sum/base;
  }

  while(carry!=0)
  {
   res.push_back(carry%base);
   carry/=base;
  } for(i=0;i<d.size();i++)
  cout<<d[i];

  while(res.back()==0)
   res.pop_back();
}

void FindRationalSum()
{
 int i,carry=0,len,sum;

 len=min(c.size(),d.size());
  for(i=0;i<len;i++)
  {
   sum=c[i]+d[i]+carry;
   ratres.push_back(sum%base);
   carry=sum/base;
  }

  for(i=len;i<c.size();i++)
  {
   sum=c[i]+carry;
   ratres.push_back(sum%base);
   carry=sum/base;
  }

  for(i=len;i<d.size();i++)
  {
   sum=d[i]+carry;
   ratres.push_back(sum%base);
   carry=sum/base;
  }

  if(carry!=0)
   fl=true;

  while(ratres.back()==0)
   ratres.pop_back();
}

void Add1()
{
 int i,carry=0,len,sum;
 vector <int> temp;

 temp.push_back(1);
 len=min(res.size(),temp.size());
  for(i=0;i<len;i++)
  {
   sum=res[i]+temp[i]+carry;
   realres.push_back(sum%base);
   carry=sum/base;
  }

  for(i=len;i<res.size();i++)
  {
   sum=res[i]+carry;
   realres.push_back(sum%base);
   carry=sum/base;
  }

  for(i=len;i<temp.size();i++)
  {
   sum=temp[i]+carry;
   realres.push_back(sum%base);
   carry=sum/base;
  }

  while(carry!=0)
  {
   realres.push_back(carry%base);
   carry/=base;
  }

  while(realres.back()==0)
   realres.pop_back();
}

int main()
{

int i,dot1,dot2,bracket1,bracket2;

ios::sync_with_stdio(false);
cin.tie(NULL);

cin>>base;
cin>>s1>>s2;

dot1=s1.size()-1;
 for(i=0;i<s1.size();i++)
 {
  if(s1[i]=='.')
  {
   dot1=i-1;
   break;
  }
 }

 for(i=dot1;i>=0;i--)
  a.push_back(Digit(s1[i]));

dot2=s2.size()-1;
 for(i=0;i<s2.size();i++)
 {
  if(s2[i]=='.')
  {
   dot2=i-1;
   break;
  }
 }

 for(i=dot2;i>=0;i--)
  b.push_back(Digit(s2[i]));

FindSum();

bracket1=s1.size()-1;
 for(i=dot1;i<s1.size();i++)
 {
  if(s1[i]=='(')
  {
   bracket1=i-1;
   break;
  }
 }

 for(i=bracket1;i>=dot1+2;i--)
  c.push_back(Digit(s1[i]));

bracket2=s2.size()-1;
 for(i=dot2;i<s2.size();i++)
 {
  if(s2[i]=='(')
  {
   bracket2=i-1;
   break;
  }
 }

 for(i=bracket2;i>=dot2+2;i--)
  d.push_back(Digit(s2[i]));

FindRationalSum();

 if(!fl)
 {
   for(i=res.size()-1;i>=0;i--)
    partans.push_back(Character(res[i]));

   if(!ratres.empty())
   {
    partans.push_back('.');

    for(i=ratres.size()-1;i>=0;i--)
     partans.push_back(Character(ratres[i]));
   }

  cout<<partans<<endl;
 }
 else
 {
  Add1();

   for(i=realres.size()-1;i>=0;i--)
    partans.push_back(Character(realres[i]));

   if(!ratres.empty())
   {
    partans.push_back('.');

    for(i=ratres.size()-1;i>=0;i--)
     partans.push_back(Character(ratres[i]));
   }

  cout<<partans<<endl;
 }

return 0;
}
