#include <iostream>
#include <cstdlib>
#include <vector>
using namespace std;

int n, m;
vector < vector < char > > cc ;
int dx[4] = {1, 0, -1, 0 };
int dy[4] = { 0, -1, 0, 1 };

pair < int, int > myMove( int y, int x ) {
    cc[y][x] = '#';
    for ( int i = 0 ; i < 4 ; i ++ ) {
        if ( x+dx[i] >= 0 && x+dx[i] < cc[0].size() && y+dy[i] >= 0 && y+dy[i] < cc.size() ) {
            return make_pair( y+dy[i], x+dx[i] );
        }
    }
}

pair < int, int > makeMove( int i, int j );

void play( int a, int b, vector < vector < char > > &table ) {
    srand( 42 );
    cc = table;

    pair < int, int > pos = makeMove(-1,-1);

    for( ; pos.first != -1 ; ) {
        pos = myMove( pos.first, pos.second );
        pos = makeMove( pos.first, pos.second );
    }
}
