#include <iostream>
#include <string>
#include <algorithm>
using namespace std;
int p;
string inputA, inputB;

string a1, a2, a3;
string b1, b2, b3;
string sum1, sum2, sum3;

inline int tod ( char c ) {
    if( c >= 'A' && c <= 'Z' ) { return c+10-'A'; }
    return c-'0';
}
inline char tos ( int c ) {
    if ( c >= 10 ){ return 'A' + c-10; }
    return c+'0';
}
int fl[(1<<20)];
inline int getPer( string c ) {
    if ( c.size() == 0 ) { return 0;}

    fl[0] = -1;
    for ( int i = 0 ; i < c.size() ; i ++ ) {
        fl[i+1] = 0;
        for ( int j = fl[i] ; j != -1 ; j = fl[j] ) {
            if ( c[i] == c[j] ) {
                fl[i+1] = j+1;
                break;
            }
        }
    }

    int d = c.size()-fl[c.size()];

    if ( c.size()%d || fl[c.size()] %d ) {
        d = c.size();
    }
    return d;
}

string toN ( string sum1 ) {
    int d = getPer( sum1 );
    string ret = "";
    for ( int i = 0 ; i < d; i ++ ) {
        ret += sum1[i];
    }
    return ret;
}

pair < int, string > add3 ( string a3, string b3 ) {
    string sum1 = "";
    string a = a3, b = b3;

    if ( a.size() == 0 ) { return make_pair( 0, toN(b) ); }
    if ( b.size() == 0 ) { return make_pair( 0, toN(a) ); }

    for ( ; a.size() != b.size() ; ) {
        if ( a.size() < b.size() ) { a += a3; }
        else { b += b3; }
    }

    int memAll = 0;
    int mem = 0;

    for ( int i = a.size()-1 ; i >= 0 ; i -- ) {
        mem = mem+ tod(a[i] ) + tod(b[i]);
        sum1 += tos( mem%p );
        mem /= p;
    }
    memAll = mem;

    if ( mem ) {
        string sum2 = "";
        for ( int i= 0 ; i < sum1.size() ; i ++ ) {
            mem = mem + tod( sum1[i] );
            sum2 += tos( mem%p );
            mem /= p;
        }
        sum1 = sum2;
    }
    reverse( sum1.begin(), sum1.end() );
    sum1 = toN( sum1 );
    return make_pair( memAll, sum1 );
}

string add ( string a, string b ) {
    reverse( a.begin(), a.end() );
    reverse( b.begin(), b.end() );
    for ( ; a.size() < b.size() ; a += "0" ){}
    for ( ; a.size() > b.size() ; b += "0" ){}

    string ret = "";
    int mem = 0;

    for ( int i =  0 ; i < a.size() ; i ++ ) {
        mem = mem + tod(a[i] ) + tod(b[i]);

 //       cout << "+ dig " << a[i] << " + " << b[i] << " : " << mem << " : " << p << "\n";
        ret += tos( mem%p );
        mem /= p;
    }

    if(  mem ) {
        ret += tos( mem );
    }

    reverse( ret.begin(), ret.end() );
    return ret;
}

void get3 () {
    int si = 0;
    for ( ; si < inputA.size() && inputA[si] != '(' ; si ++ ) {}

    si ++;
    for ( ; si < inputA.size()-1 ; si ++ ) {
        a3 +=inputA[si];
    }

    si = 0;
    for ( ; si < inputB.size() && inputB[si] != '(' ; si ++ ) {}
    si ++;

    for ( ; si < inputB.size()-1 ; si ++ ) {
        b3 += inputB[si];
    }
}
void get1 () {
    int si = 0;
    for ( ; si < inputA.size() && inputA[si] != '.' ; si ++ ) { a1 += inputA[si]; }

    si = 0;
    for ( ; si < inputB.size() && inputB[si] != '.' ; si ++ ) { b1 += inputB[si]; }

}

void get2 () {
    int si = 0;
    for ( ; si < inputA.size() && inputA[si] != '.' ; si ++ ) {}
    si ++;
    for ( ; si < inputA.size() && inputA[si] != '(' ; si ++ ) {
        a2 += inputA[si];
    }

    si = 0;
    for ( ; si < inputB.size() && inputB[si] != '.' ; si ++ ) {}
    si ++;
    for ( ; si < inputB.size() && inputB[si] != '(' ; si ++ ) {
        b2 += inputB[si];
    }

}
string tostr ( int x ) {
    string ret = "";
    for ( ; x ; x /= p ) {
        ret += tos( x%p );
    }
    reverse( ret.begin(), ret.end() );
    return ret;
}
bool sameEnd ( string a, string b ) {
    if ( a.size() < b.size() ) { return 0; }

    for ( int i = a.size() - b.size() ; i < a.size() ; i ++ ) {
        if ( a[i] != b[ i - a.size()+b.size() ] ) { return 0; }
    }
    return 1;
}

int main () {
    cin >> p;
    cin >> inputA >> inputB;

    get1();
    get2();
    get3();

//    cout << "here\n";

//    cout << a1 << "." << a2 << "." << a3 << "\n";
//    cout << b1 << "." << b2 << "." << b3 << "\n";

    b3 = toN(b3);
    a3 = toN(a3);

    if ( b3.size() == 0 && b3[0] == '0' ) { b3 = ""; }
    if ( a3.size() == 0 && a3[0] == '0' ) { a3 = ""; }

    for ( ; a2.size() != b2.size() ; ) {
        if ( a2.size() < b2.size() ) {
            if ( a3.size() ) {
                a2 += a3[0];
                char c = a2.back();
                for ( int i = 0 ; i < a3.size()-1 ; i ++ ) {
                    a3[i] = a3[i+1];
                }
                a3[ a3.size()-1 ] = c;
            }
            else { a2 += "0"; }
        }else {
            if ( b3.size() ) {

                b2 += b3[0];
                char c = b2.back();
                for ( int i = 0 ; i < b3.size()-1 ; i ++ ) {
                    b3[i] = b3[i+1];
                }
                b3[ b3.size()-1 ] = c;

            }
            else { b2 += "0"; }
        }
    }

//    cout << a1 << "." << a2 << "." << a3 << "\n";
//    cout << b1 << "." << b2 << "." << b3 << "\n";


//    cout << "here\n";

    reverse( a1.begin(), a1.end() );
    reverse( b1.begin(), b1.end() );
    for ( ; a1.size() < b1.size() ; a1 += "0" ){}
    for ( ; a1.size() > b1.size() ; b1 += "0" ){}
    reverse( a1.begin(), a1.end() );
    reverse( b1.begin(), b1.end() );


  //  cout << a1 << " " << a2 << " " << a3 << "\n";
  //  cout << b1 << " " << b2 << " " << b3 << "\n";

    pair < int, string > ans3 = add3( a3, b3 );

    if ( ans3.second.size() == 1 && ans3.second[0] == tos( p-1 ) ) { ans3.first ++; ans3.second = ""; }

    string cc = tostr( ans3.first );

    string ans2 = add( a2, b2 );
    ans2 = add( ans2, cc );

    string mem = "", rem = "";
    int cd = a2.size();
    for ( int i = 0 ; i < ans2.size()-cd ; i ++ ) {
        mem += ans2[i];
    }
    for ( int i = ans2.size()-cd ; i < ans2.size() ; i ++ ) {
        rem += ans2[i];
    }
    ans2 = rem;

    string ans1 = add( a1, b1 );
    ans1 = add( ans1, mem );

    if( ans3.second.size() ) {
        while ( sameEnd( ans2, ans3.second ) ) {
            for ( int i = 0 ; i < ans3.second.size() ; i ++ ) { ans2.pop_back(); }
        }
    }else {
        for ( ; ans2.size() && ans2.back() == '0' ; ans2.pop_back() ) {}
    }

    if ( ans2.size() == 0 ) {
        if ( ans3.second.size() == 1 && ans3.second[0] == '0' ) { ans3.second = ""; }
    }

    reverse( ans1.begin(), ans1.end() );
    for ( ; ans1.size() > 1 && ans1.back() == '0' ; ans1.pop_back() ) {}
    reverse( ans1.begin(), ans1.end() );

    if( ans2.size() == 0 && ans3.second.size() == 0 ) {
        cout << ans1 << "\n";
    }else {
        cout << ans1 << "." << ans2;
        if ( ans3.second.size() ) {
            cout << "(" << ans3.second << ")";
        }
        cout << "\n";
    }

    return 0;
}


/*

10
0.0(55)
0.(99)


5
1242.1(2)
002.322(22)
*/
