#include "hunter.h"
#include<vector>
#include<algorithm>
#include<iostream>
using namespace std;
bool cmp (pair<int, int> x, pair<int,int> y)
{
    if (x.first!=y.first)
        return x.first>y.first;
    return x.second<y.second;
}
void play (int n, int m, const vector<vector<char> > &table)
{
    vector<pair<int,int> > v;
    int br=0,pos=0;
    for (int j=0; j<m; j++)
    {
        if (table[0][j]=='.')
        {
            if (br==0)
                pos=j;
            br++;
        }
        else
        {
            if (br!=0)
                v.push_back(make_pair(br,pos));
            br=0;
        }
    }
    if (br!=0)
        v.push_back(make_pair(br,pos));
    bool flag=false;
    for (int i=0; i<v.size(); i++)
    {
        if (v[i].first%2==1)
        {
            int q=v[i].second;
            pair<int,int> z=make_pair(0,0);
            while (z!=make_pair(-1,-1))
            {
                z=makeMove(0,q);
                q+=2;
            }
            flag=true;
            break;
        }
    }
    if (flag)
        return;
    pair<int,int> z=makeMove(-1,-1);
    int s,f;
    s=f=z.second;
    while (s>=0 && table[0][s]=='.')
        s--;
    s++;
    while (f<m && table[0][f]=='.')
        f++;
    f--;
    if ((f-z.second+1)%2==1)
    {
        int q=z.second+1;
        while (z!=make_pair(-1,-1))
        {
            z=makeMove(0,q);
            q+=2;
        }
    }
    else
    {
        int q=z.second-1;
        while (z!=make_pair(-1,-1))
        {
            z=makeMove(0,q);
            q-=2;
        }
    }
}

