#include<iostream>
#include<cstring>
#include<vector>
#include<set>
#include<map>
#include<cstdio>
#include<cstdlib>
#include<algorithm>
#include<cmath>
#include<queue>
#include<ctime>
using namespace std;
struct node
{
    int to,s;
    node() {};
    node(int _to, int _s)
    {
        to=_to;
        s=_s;
    }
};
int n,m,k;
vector<node> v[50005];
vector<int> ss;
int par[50005],cnt[50005];
int find_par(int x)
{
    if(x==par[x]) return x;
    return par[x]=find_par(par[x]);
}
void read()
{
    int i,j,x,y,s;
    cin>>n>>m>>k;
    for(i=0;i<m;i++)
    {
        cin>>x>>y>>s;
        if(x!=y)
        {v[x].push_back(node(y,s));
        v[y].push_back(node(x,s));
        ss.push_back(s);
        }
    }
}
int idx;
int used[50005];
int ans=-1;
map<int,int> M[50005];
/*int check3(int x, int gr)
{
    queue<int> q;
    int i,j;
    node nb;
    int sz;
    int w;
    if(x==1) q.push(2);
    else q.push(1);
    used[q.front()]=1;
    int cnt=1;
    while(!q.empty())
    {
        cnt++;
        w=q.front();
        q.pop();
        sz=v[w].size();
        for(i=0;i<sz;i++)
        {
            nb=v[w][i];
            if(nb.to==x||used[nb.to]||nb.s<=gr)
                continue;
            used[nb.to]=1;
            q.push(nb.to);
        }
    }
    if(cnt<n) return 1;
    return 0;
}
*/
int check4(int gr)
{
    queue<int> q;
    int i,j;
    node nb;
    int sz;
    int w;
    q.push(1);
    int cnt=0;
    used[1]=1;
    while(!q.empty())
    {
        cnt++;
        w=q.front();
        q.pop();
        sz=v[w].size();
        for(i=0;i<sz;i++)
        {
            nb=v[w][i];
            if(used[nb.to]||nb.s<=gr)
                continue;
            used[nb.to]=1;
            q.push(nb.to);
        }
    }
    if(cnt!=n) return 0;
    return 1;
}
/*
int check2(int gr, int l)
{
    int i,j;
    int cnt=0;
    for(i=1;i<=n;i++)
    {
        memset(used,0,sizeof(used));
        if(check3(i,gr))
        {
            cnt++;
            if(l==1) cout<<i<<" ";
        }
    }
    return cnt;
}*/
int id[50005];
int look(int x, int tg)
{
    if(x==tg)
    {
        return 1;
    }
    int mn=min(x,par[x]);
    int mx=max(x,par[x]);
    if(M[mn][mx])
    {
        return 0;
    }
    look(par[x],tg);
}
void upd(int x, int tg, int t)
{
    int mn=min(x,tg);
    int mx=max(x,tg);
    M[mn][mx]=1;
    if(t==1)
        cnt[x]++;
    else if(!cnt[x])
        cnt[x]=1;
    if(x==tg) return;
    upd(par[x],tg,t);
}
void dfs(int x, int gr)
{
    //cout<<x<<endl;
    int i,j,sz;
    node nb;
    int L;
    sz=v[x].size();
    int mn,mx;
    for(i=0;i<sz;i++)
    {
        nb=v[x][i];
        mn=min(x,nb.to);
        mx=max(x,nb.to);
        if(nb.to==par[x]||nb.s<=gr||M[mn][mx])
            continue;
        //cout<<x<<" "<<v[x][i].to<<endl;
        if(!par[nb.to])
        {
            par[nb.to]=x;
            dfs(nb.to,gr);
        }
        else
        {
            if(M[mn][mx])
                L=0;
            else L=look(x,nb.to);
            if(L)
            {
                M[mn][mx]=1;
                upd(x,nb.to,1);
            }
            else
            {
                upd(x,nb.to,0);
            }
        }
    }
}
int check2(int gr, int t)
{
    par[1]=1;
    dfs(1,gr);
    int i,j;
    int br=0;
    node nb;
    int nbr;
    for(i=1;i<=n;i++)
    {
        int sz=v[i].size();
        nbr=0;
        for(j=0;j<sz;j++)
        {
            if(v[i][j].s>gr) nbr++;
        }
        if(nbr<=1) continue;
        if(cnt[i]!=1)
        {
            br++;
            if(t) cout<<i<<" ";
        }
        else
        {
            for(j=0;j<sz;j++)
            {
                nb=v[i][j];
                if(nb.s<=gr)
                    continue;
                if(!cnt[nb.to])
                {
                    if(t)
                        cout<<i<<" ";
                    br++;
                    break;
                }
            }
        }
    }
    return br;
}
int sc[200005];
void solve()
{
    int l=-1,r,mid;
    int i,j;
    ss.push_back(0);
    sort(ss.begin(),ss.end());
    r=ss.size();
    int lol=0;
    while(l+1<r)
    {
        memset(used,0,sizeof(used));
        mid=(l+r)/2;
        if(!check4(ss[mid]))
        {
            sc[mid]=0;
            r=mid;
            continue;
        }
        memset(par,0,sizeof(par));
        memset(cnt,0,sizeof(cnt));
        for(i=1;i<=n;i++)
            M[i].clear();
        sc[mid]=check2(ss[mid],0);
        //cout<<ss[mid]<<" "<<sc[mid]<<endl;
        if(sc[mid]>=k)
        {
            ans=mid;
            r=mid;
        }
        else
        {
            l=mid;
        }
    }
    memset(par,0,sizeof(par));
    memset(cnt,0,sizeof(cnt));
    for(i=1;i<=n;i++)
        M[i].clear();
    if(ans==-1)
    {
        cout<<-1<<" "<<0<<endl;
    }
    else
    {
        cout<<ss[ans]<<" "<<sc[ans]<<endl;
        check2(ss[ans],1);
        cout<<endl;
    }
    return;
}
int main()
{
	read();
	solve();
	return 0;
}
