#include<iostream>
#include<vector>
#include<algorithm>
#include<queue>
using namespace std;

vector<pair<int,long long> > susedi[200001];
vector<bool> raboti[200001];
long long rebra[200001];

queue<pair<int,long long> > opashka;
bool used[50001],curr[50001];
void obnovi(int vruh,int snqg){
	used[vruh]=true;
	opashka.push({vruh,0});
	while(!opashka.empty()){
		cout<<vruh<<" ";
		vruh=opashka.front().first;
		opashka.pop();
		for(int i=0;i<susedi[vruh].size();i++){
			if(susedi[vruh][i].second<=snqg){
				//cout<<" ("<<vruh<<"->"<<susedi[vruh][i].first<<": "<<susedi[vruh][i].second<<" "<<snqg<<") ";
				raboti[vruh][i]=false;
			}
			if(!used[susedi[vruh][i].first] and raboti[vruh][i]){
				opashka.push(susedi[vruh][i]);
				used[susedi[vruh][i].first]=true;
			}
		}
	}
	//cout<<endl;
}

void bfs(int vruh,int bez){
	used[vruh]=true;
	opashka.push({vruh,0});
	while(!opashka.empty()){
		cout<<vruh<<" ";
		vruh=opashka.front().first;
		opashka.pop();
		for(int i=0;i<susedi[vruh].size();i++){
			if(!used[susedi[vruh][i].first] and raboti[vruh][i] and susedi[vruh][i].first!=bez){
				opashka.push(susedi[vruh][i]);
				used[susedi[vruh][i].first]=true;
			}
		}
	}
	//cout<<endl;
}

int n,m,k;

bool stava(int koe) {
	for(int i=0;i<=n;i++){
		used[i]=false;
	}
	int start=-1,last=-1;
	for(int i=1;i<=n;i++){
		for(int j=0;j<raboti[i].size();j++){
			raboti[i][j]=true;
			if(susedi[i][j].second>rebra[koe]){
				last=start;
				start=i;
			}
		}
	}
	obnovi(start,rebra[koe]);
	int opasen=0;
	for(int i=1;i<=n;i++){
		for(int j=1;j<=n;j++){
			curr[j]=false;
		}
		if(i!=start){
			bfs(start,i);
		}else{
			bfs(last,start);
		}
		for(int j=1;j<=n;j++){
			if(used[j]!=curr[j]){
				opasen++;
				break;
			}
		}
		
	}
	return opasen>=k;
}

int main(){
	cin>>n>>m>>k;
	for(int i=1;i<=n;i++){
		susedi[0].push_back({i,2000000000});
		raboti[0].push_back(true);
	}
	for(int i=0;i<m;i++){
		int a,b;
		long long c;
		cin>>a>>b>>c;
		//if(a==b);
		susedi[a].push_back({b,c});
		susedi[b].push_back({a,c});
		raboti[a].push_back(true);
		raboti[b].push_back(true);
		rebra[i]=c;
	}
	sort(rebra,rebra+m);
	
	int l=0,r=m,mid=(l+r)/2;
	while(l<r){
		if(stava(mid)){
			r=mid;
		}else{
			l=mid;
		}
		mid=(l+r)/2;
	}
	int	nomer=r;
	if(stava(l)){
		nomer=l;
	}
	cout<<nomer<<endl;
	return 0;
}
