#include <iostream>
#include <string>
#include <algorithm>

using namespace std;

struct num
{
    string c, d, p;
};

num a, b, sum;
int p;

void get_num(num &a)
{
    int flag=0;
    char x=cin.get();
    while(x!='\n')
    {
        if(('0'<=x&&x<='9'||'A'<=x&&x<='Z'))
        {
            if(flag==0)
                a.c+=x;
            else if(flag==1)
                a.d+=x;
            else
                a.p+=x;
        }
        else if(x=='.')flag=1;
        else if(x=='(')flag=2;
        x=cin.get();
    }
}

void convert (string &a)
{
    for(uint32_t i=0; i<a.size(); i++)
    {
        if('0'<=a[i]&&a[i]<='9')a[i]-='0';
        else a[i]=a[i]-'A'+10;
    }
}

void show(const string &a)
{
    for(uint32_t i=0; i<a.size(); i++)
    {
        cout<<(short)a[i]<<' ';
    }
}

void remove_leading_zeros (string &a)
{
    int32_t pos=a.size()-1;
    while(pos>0&&a[pos]==0)pos--;
    if(pos<0)
    {
        a.resize(1);
        a[0]=0;
        return;
    }
    //cout<<"ASD:"<<pos<<endl;
    string tmp;
    tmp=a.substr(0, pos+1);
    a=tmp;
}

void add_leading_zeros (string &a, uint32_t to_size)
{
    while(a.size()<to_size)
    {   a.resize(a.size()+1);
        a[a.size()-1]=0;
        //cout<<"ASD: "<<a.size()<<endl;
    }
}

void sum_str (const string &a, const string &b, string &sum)
{
    sum.resize(max(a.size(), b.size())+1);
    for(uint32_t i=0; i<sum.size(); i++)
        sum[i]=0;
    bool carry=false;
    for(uint32_t i=0; i<max(a.size(), b.size()); i++)
    {
        sum[i]=a[i]+b[i]+carry;
        carry=false;
        if(sum[i]>=p)
        {
            carry=true;
            sum[i]-=p;
        }
    }
    if(carry)
        sum[max(a.size(), b.size())]=1;
}

void init()
{   ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin>>p;
    cin.get();
    get_num(a);
    get_num(b);
    if(a.p.size()+b.p.size())exit(0);
    convert(a.c);
    convert(a.d);
    convert(a.p);
    convert(b.c);
    convert(b.d);
    convert(b.p);
    uint32_t tmp=max(a.d.size(), b.d.size());
    add_leading_zeros(a.d, tmp);
    add_leading_zeros(b.d, tmp);
    //show(a.c);cout<<"         ";show(b.c);cout<<endl;
    //show(a.d);cout<<"         ";show(b.d);cout<<endl;
    //cout<<"---------------"<<endl;
    reverse(a.c.begin(), a.c.end());
    reverse(a.d.begin(), a.d.end());
    reverse(a.p.begin(), a.p.end());
    reverse(b.c.begin(), b.c.end());
    reverse(b.d.begin(), b.d.end());
    reverse(b.p.begin(), b.p.end());
    remove_leading_zeros(a.c);
    //remove_leading_zeros(a.d);
    remove_leading_zeros(a.p);
    remove_leading_zeros(b.c);
    //remove_leading_zeros(b.d);
    remove_leading_zeros(b.p);
    tmp=max(a.c.size(), b.c.size());
    add_leading_zeros(a.c, tmp);
    add_leading_zeros(b.c, tmp);

    //show(a.c);cout<<"         ";show(b.c);cout<<endl;
    //show(a.d);cout<<"         ";show(b.d);cout<<endl;
    //cout<<"---------------"<<endl;
}

string to_normal(const string &a)
{
    string res;
    res.resize(a.size());
    for(uint32_t i=0; i<a.size(); i++)
    {
        if(0<=a[i]&&a[i]<=9)res[i]=a[i]+'0';
        else res[i]=a[i]-10+'A';
    }
    return res;
}

void solve()
{
    sum_str(a.c, b.c, sum.c);
    //show(sum.c);cout<<endl;
    sum_str(a.d, b.d, sum.d);
    //show(sum.d);cout<<endl;
    //cout<<"---------------"<<endl;
    if(sum.d[sum.d.size()-1]==1)
    {
        string tmp, tmp2;
        tmp.resize(sum.c.size());
        tmp[0]=1;
        for(uint32_t i=1; i<sum.c.size(); i++)
            tmp[i]=0;
        sum_str(sum.c, tmp, tmp2);
        sum.c=tmp2;
        sum.d[sum.d.size()-1]=0;
    }
    sum.d.resize(sum.d.size()-1);
    remove_leading_zeros(sum.c);
    reverse(sum.c.begin(), sum.c.end());
    reverse(sum.d.begin(), sum.d.end());
    reverse(sum.p.begin(), sum.p.end());
    remove_leading_zeros(sum.d);
    //show(sum.c);cout<<endl;
    //show(sum.d);cout<<endl;

    if(sum.d.size()==1&&sum.d[0]==0)
        cout<<to_normal(sum.c)<<endl;
    else
        cout<<to_normal(sum.c)<<'.'<<to_normal(sum.d)<<endl;
}

int main()
{
    init();
    solve();

    return 0;
}
