#include<iostream>
#include<vector>
#include<queue>
#include<algorithm>
#define endl '\n'

using namespace std;

const int MAXV=50000;
const int MAXE=200000;
int n;
int v, e, k;
/*struct connection
{
    int to;
    int price;
};*/
struct connection2
{
    int to;
    int price;
    int pl;
    int pl2;
};
bool operator<(connection2 l, connection2 r)
{
    return l.price>r.price;
}
vector<int> con[MAXV+10];
int danc=0;
int dangerous[MAXV+10];
bool dan[MAXV+10];
priority_queue<connection2> pq;
bool used[MAXV+10];
//int parent[MAXV+10];
int visited;
int minp=0;

void input()
{
    connection2 temp;
    int a, b, c;
    cin>>v>>e>>k;
    for (int i=0; i<e; i++)
    {
        cin>>a>>b>>c;
        con[a-1].push_back(b-1);
        con[b-1].push_back(a-1);
        temp.to=b-1;
        temp.price=c;
        temp.pl=con[b-1].size()-1;
        temp.pl2=con[a-1].size()-1;
        pq.push(temp);
    }
}

void output()
{
    if (minp>-1)
    {
        sort(dangerous, dangerous+danc);
        /*
        int temp, temp2;
        for (int i=0; i<danc; i++)
        {
            temp=-1;
            temp2=0;
            for (int j=i; j<danc; j++)
            {
                if (temp<dangerous[j])
                {
                    temp=dangerous[j];
                    temp2=j;
                }
            }
            swap(dangerous[i], dangerous[temp2]);
        }*/
        /*for (int i=0; i<v; i++)
        {
            cerr<<i+1<<": ";
            for (int j=0; j<con[i].size(); j++)
            {
                cerr<<con[i][j]+1<<' ';
            }
            cerr<<endl;
        }*/
        cout<<minp<<' '<<danc<<endl;
        for (int i=0; i<danc; i++)
        {
            cout<<dangerous[i]+1<<' ';
        }
        cout<<endl;
    }
    else cout<<-1<<' '<<0<<endl;
}

/*void prim(int index)
{
    connection temp;
    pq.push({index, 0});
    while (!pq.empty())
    {
        temp=pq.top;
        used[temp.to]=1;
        for (int i=0; i<con[temp.top].size(); i++)
        {
            if (!used[con[temp.top][i]])
            {
                pq.push()
            }
        }
    }
}*/

void zeroing()
{
    visited=0;
    for (int i=0; i<v; i++)
    {
        used[i]=0;
    }
}

void dfs(int curr, int donot)
{
    used[curr]=1;
    visited++;
    for (int i=0; i<con[curr].size(); i++)
    {
        if (!used[con[curr][i]] && con[curr][i]!=donot)
            dfs(con[curr][i], donot);
    }
}
/*
void dfs2(int curr, int prev)
{
    parent[curr]=prev;
    used[curr]=1;
    for (int i=0; i<con[curr].size(); i++)
    {
        if (!used[con[curr][i]])
            dfs2(con[curr][i], curr);
        if (parent[con[curr][i]]!=)
        else if (parent[con[curr][i]]<parent[curr])
            parent[curr]=parent[con[curr][i]];
        else parent[con[curr][i]]=parent[curr];
    }
}

int critical_point()
{
    dfs2(0, 0);
    for (int i=0; i<v; i++)
    {
        cerr<<parent[i]<<' ';
        if (1);
    }
    cerr<<endl;
}
*/

void solve()
{
    //cerr<<endl;
    int ch;
    connection2 temp;
    int temp2;
    for (int i=0; i<e; i++)
    {
        ch=pq.top().price;
        while(pq.top().price==ch)
        {
            temp=pq.top();
            temp2=con[temp.to][temp.pl];
            //cerr<<temp.to+1<<' '<<temp.price<<' '<<con[temp.to][temp.pl]+1<<' '<<con[temp2][temp.pl2]+1<<endl;
            swap(con[temp.to][temp.pl], con[temp.to][con[temp.to].size()-1]);
            con[temp.to].pop_back();
            swap(con[temp2][temp.pl2], con[temp2][con[temp2].size()-1]);
            con[temp2].pop_back();
            if (con[temp2].size()==0)
            {
                minp=-1;
                return;
            }
            if (con[temp.to].size()==0)
            {
                minp=-1;
                return;
            }
            for (int j=1; j<v; j++)
            {
                if (dan[j]==0)
                {
                    zeroing();
                    dfs(0, j);

                    if (visited<v-1)
                    {
                        dan[j]=1;
                        dangerous[danc++]=j;
                    };
                }
            }
            if (dan[0]==0)
            {
                zeroing();
                dfs(1, 0);
                if (visited<v-1)
                {
                    dan[0]=1;
                    dangerous[danc++]=0;
                };
            }
            pq.pop();
            i++;
        }
        if (danc>=k)
        {
            minp=ch;
            return;
        }
        i--;
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    input();
    solve();
    output();
    return 0;
}
/*
3 3 1
1 2 42
2 3 42
1 3 666

8 13 3
1 2 19
1 3 13
2 3 5
4 2 9
2 5 7
3 5 17
6 3 8
3 8 12
4 7 11
5 7 5
7 2 10
7 6 13
8 5 16

8 10 3
1 2 19
1 3 13
4 2 9
3 5 17
6 3 8
3 8 12
4 7 11
7 2 10
7 6 13
8 5 16
*/

