#include "hunter.h"

#include <iostream>
#include <vector>
using namespace std;

void startPlay1n(int i, int j){
    pair<int,int> enMove = makeMove(i,j);

    while(!(enMove.first == -1 && enMove.second == -1)){
        enMove = makeMove(enMove.first, enMove.second+1);
    }
}

void play(int n, int m, const vector<vector<char> > &table){
    bool gameEnded = false;
    if(n==1){
        int a = 0;
        int st = 0;
        while(st < m){
            a = st+1;
            while(a < m && table[0][a] != '#'){
                //cout<<"Izbiram a="<<a<<endl;
                a++;
            }
            a--;
            if((a-st+1) % 2 == 1){
                //cout<<"Necheten broi kletki ot " << st << " do " << a <<endl;
                startPlay1n(0, st);
                return;
            }
            st = a+2;
        }
        startPlay1n(-1,-1);
    }
}
