#include<iostream>
#include<stdio.h>
#include<string>
#include<vector>
using namespace std ;

int b ;
string s1 , s2;


vector < int > whole1 , whole2 ;
vector < int > frac1 , frac2 ;
vector < int > per1 , per2 ;


int extr_val ( char c ) {
	if ( c >= '0' && c <= '9' ) { return ( c - '0' ) ; } 
	return ( 10 + ( c - 'A' ) ) ;
}

vector < int > extr_whole ( string arg ) {
	int i ;
	int sz = arg.size ( ) ;
	vector < int > ret ;
	ret.clear ( ) ;
	for ( i = 0 ; i < sz ; i ++ ) {
		if ( arg[ i ] == '.' ) { break ; }
		ret.push_back ( extr_val ( arg[ i ] ) ) ;
	}
	return ret ;
}
vector < int > extr_frac ( string arg ) {
	int i ;
	int sz = arg.size ( ) ;
	vector < int > ret ;
	ret.clear ( ) ;
	bool fl = false ;
	for ( i = 0 ; i < sz ; i ++ ) {
		if ( arg[ i ] == '(' ) { break ; }
		if ( arg[ i ] =='.' ) { fl = true ; continue ; }
		if ( fl == true ) {
			ret.push_back ( extr_val ( arg[ i ] ) ) ;
		}
	}
	return ret ;
}

vector < int > extr_per ( string arg ) {
	int i ;
	int sz = arg.size ( ) ;
	vector < int > ret ;
	ret.clear ( ) ;
	bool fl = false ;
	for ( i = 0 ; i < sz ; i ++ ) {
		if ( arg[ i ] == ')' ) { break ; }
		if ( arg[ i ] == '(' ) { fl = true ; continue ; }
		if ( fl == true ) {
			ret.push_back ( extr_val ( arg[ i ] ) ) ;
		}
	}
	return ret ;
}

vector < int > rot ( vector < int > v , int pos ) {	
	vector < int > ret ;
	ret.clear ( ) ;
	int i ;
	int sz = v.size ( ) ;
	for ( i = pos ; i < sz ; i ++ ) {
		ret.push_back ( v[ i ] ) ;
	}
	for ( i = 0 ; i < pos ; i ++ ) {
		ret.push_back ( v[ i ] ) ;
	}
	return ret ;
}

void append ( vector < int > &v , vector < int > &aux ) {
	int i ;
	int sz = aux.size ( ) ;
	for ( i = 0 ; i < sz ; i ++ ) {
		v.push_back ( aux[ i ] ) ;
	}
}

vector < int > rev ( vector < int > v ) {
	vector < int > ret ;
	ret.clear ( ) ;
	int i ;
	int sz = v.size ( ) ;
	for ( i = sz - 1 ; i >= 0 ; i -- ) {
		ret.push_back ( v[ i ] ) ;
	}
	return ret ;
}

vector < int > add ( vector < int > v1 , vector < int > v2 ) {
	vector < int > ret ;
	ret.clear ( ) ;
	v1 = rev ( v1 ) ;
	v2 = rev ( v2 ) ;
	while ( v1.size ( ) < v2.size ( ) ) { v1.push_back ( 0 ) ; }
	while ( v2.size ( ) < v1.size ( ) ) { v2.push_back ( 0 ) ; }
	int sz = v1.size ( ) ;
	int i , p ;
	p = 0 ;
	for ( i = 0 ; i < sz ; i ++ ) {
		int c = ( v1[ i ] + v2[ i ] + p ) ;
		ret.push_back ( ( c % b ) ) ;
		p = ( c / b ) ;
	}
	if ( p != 0 ) { ret.push_back ( p ) ; }
	ret = rev ( ret ) ;
	return ret ;
}

void print ( vector < int > v ) {
	int sz = v.size ( ) ;
	int i ;
	for ( i = 0 ; i < sz ; i ++ ) {
		if ( v[ i ] >= 0 && v[ i ] <= 9 ) { printf ( "%c" , char ( ( '0' + v[ i ] ) ) ) ; }
		else { printf ( "%c" , char ( 'A' + ( v[ i ] - 10 ) ) ) ; }
	}
}

vector < int > remove_zeros ( vector < int > v ) {
	int i ;
	int sz = v.size ( ) ;
	vector < int > ret ;
	ret.clear ( ) ;
	bool fl = false ;
	for ( i = 0 ; i < sz ; i ++ ) {
		if ( v[ i ] != 0 ) { fl = true ; }
		if ( fl == true ) { ret.push_back ( v[ i ] ) ; }
	}
	if ( ret.size ( ) == 0 ) { ret.push_back ( 0 ) ; }
	return ret ;
}


void input ( ) {
	cin >> b ;
	cin >> s1 >> s2 ;
	whole1 = extr_whole ( s1 ) ;
	frac1 = extr_frac ( s1 ) ;
	per1 = extr_per ( s1 ) ;
	
	
	whole2 = extr_whole ( s2 ) ;
	frac2 = extr_frac ( s2 ) ;
	per2 = extr_per ( s2 ) ;	
	int pos = 0 ;
	while ( frac1.size ( ) < frac2.size ( ) ) {
		frac1.push_back ( per1[ pos ] ) ;
		pos ++ ;
		if ( pos == per1.size ( ) ) { pos = 0 ; }
		if ( frac1.size ( ) == frac2.size ( ) ) {
			per1 = rot ( per1 , pos ) ;
		}
	}
	while ( frac2.size ( ) < frac1.size ( ) ) {
		frac2.push_back ( per2[ pos ] ) ;
		pos ++ ;
		if ( pos == per2.size ( ) ) { pos = 0 ; }
		if ( frac1.size ( ) == frac2.size ( ) ) {
			per2 = rot ( per2 , pos ) ;
		}
	}
	vector < int > init1 , init2 ;
	init1 = per1 ;
	init2 = per2 ;
	while ( per1.size ( ) != per2.size ( ) ) {
		if ( per1.size ( ) < per2.size ( ) ) { append ( per1 , init1 ) ; }
		else { append ( per2 , init2 ) ; }
	}
}

void solve ( ) {
	int init_sz_frac = frac1.size ( ) ;
	int init_sz_per = per1.size ( ) ;
	vector < int > sum_whole = add ( whole1 , whole2 ) ;
	vector < int > sum_frac = add ( frac1 , frac2 ) ;
	vector < int > sum_per = add ( per1 , per2 ) ;	
	if ( sum_frac.size ( ) != init_sz_frac ) {
		sum_frac = rot ( sum_frac , 1 ) ;
		vector < int > aux ;
		aux.clear ( ) ;
		aux.push_back ( sum_frac[ sum_frac.size ( ) - 1 ] ) ;
		sum_whole = add ( sum_whole , aux ) ;
		sum_frac.pop_back ( ) ;
	}
	sum_whole = remove_zeros ( sum_whole ) ;
	int pos = sum_per.size ( ) - 1 ;
	while ( sum_frac.size ( ) != 0 && sum_per.size ( ) != 0 ) {
		if ( sum_frac[ sum_frac.size ( ) - 1 ] == sum_per[ pos ] ) {
			sum_frac.pop_back ( ) ;
			pos -- ;
			if ( pos < 0 ) { pos = sum_per.size ( ) - 1 ; }
		}
		else { break ; }
	}
	sum_per = rot ( sum_per , pos ) ;
	print ( sum_whole ) ;
	if ( sum_frac.size ( ) != 0 || sum_per.size ( ) != 0 ) { 
		printf ( "." ) ;
	}
	print ( sum_frac ) ;	
	if ( sum_per.size ( ) != 0 ) { printf ( "(" ) ; }
	print ( sum_per ) ;
	if ( sum_per.size ( ) != 0 ) { printf ( ")" ) ; }	
	printf ( "\n" ) ;
}

int main ( ) {
	input ( ) ;
	solve ( ) ;
	return 0 ;
}
